#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "FILE ACQ_PLUGIN TESTS"
echo
if test -d /tmp/file_unit_test
then
  rm -rf /tmp/file_unit_test/*
else
  mkdir /tmp/file_unit_test
fi
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_acq.xml > server.trace 2>&1 &
wait_until_awake localhost $ACQ_PORT
exec_n_test ./init.sh filedummy 1 /opt/pyrame/file_acq.so /opt/pyrame/uncap_dummy.so raw.ref null null 0 0 /tmp/file_unit_test none
exec_n_test ./startacq.sh filedummy
exec_n_test ./stopacq.sh filedummy
exec_n_test ./zero_stats.sh
exec_n_test ./startacq.sh filedummy
exec_n_test ./stopacq.sh filedummy
exec_n_test ./zero_stats.sh
exec_n_test ./flush_files.sh filedummy test none none none none none none

tcpc localhost $DATASTREAM_BASE_PORT > socket.trace &
exec_n_test ./startacq.sh filedummy
exec_n_test ./stopacq.sh filedummy
exec_n_test ./flush_files.sh filedummy test none none none none none none
exec_n_test ./getstats.sh
check_exist_file /tmp/file_unit_test/test_filedummy_0.raw
check_equal_files /tmp/file_unit_test/test_filedummy_0.raw res.ref
check_equal_files socket.trace res.ref
exec_n_test ./deinit.sh filedummy

clean_all
echo "all tests passed"
