#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "NOACQ ACQ_PLUGIN TESTS"
echo
rm -rf /tmp/noacq_unit_test
mkdir /tmp/noacq_unit_test
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_acq.xml > server.trace 2>&1 &
wait_until_awake localhost $ACQ_PORT
exec_n_test ./init.sh noacq 1 /opt/pyrame/noacq_acq.so /opt/pyrame/uncap_dummy.so null null null 0 0 /tmp/noacq_unit_test  none 
tcpc localhost $DATASTREAM_BASE_PORT > socket.trace &
exec_n_test ./inject_data.sh noacq 0 "84,79,84,79"
exec_n_test ./flush_files.sh noacq test none none none none none none
sleep 0.5s
check_exist_file /tmp/noacq_unit_test/test_noacq_0.raw
check_equal_files /tmp/noacq_unit_test/test_noacq_0.raw raw.ref
check_equal_files socket.trace raw.ref
exec_n_test ./deinit.sh noacq

rm -rf /tmp/noacq_unit_test
clean_all
echo "all tests passed"
