/*
Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Pyrame.

Pyrame is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Pyrame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
*/


#include "perf_acq.h"

//this function should initialize acquisition
//it should allocate and fill the specific structure
struct perfacq_workspace* init_acq(char * str_sleeptime,char *str_returnsize, char *param3) {
  
  //allocate and fill the workspace
  struct perfacq_workspace *ws=malloc(sizeof(struct perfacq_workspace));
  ws->sleeptime=atoi(str_sleeptime);
  ws->returnsize=atoi(str_returnsize);
  //do whatever needed to initialized
  //print a message if you want
  printf("perf acquisition initialized with sleeptime=%d and returnsize=%d\n",ws->sleeptime,ws->returnsize);
  //return the workspace
  return ws;
}
 
//deinit the acquisition and destroy the specific structure
int deinit_acq(struct perfacq_workspace *ws) {
  printf("deinit the performance acquisition\n");
  //destroy the specific structure
  free(ws);
  //print a message if you want
  printf("performance acquisition deinitialized\n");
  //return 1 if success 0 otherwise
  return 1;
}


//this function start the acquisition
//it effectively open the socket 
int start_acq(struct perfacq_workspace *ws) {
  //print a message if you want
  printf("perf_start_acq\n");
  return 1;
}


//this function stop the acquisition*
//it effectively close the socket
int stop_acq(struct perfacq_workspace *ws) {
  //print a message if you want
  printf("perf_stop_acq\n");
  return 1;
}

int acquire_one_block(struct perfacq_workspace *ws,unsigned char *buffer,int maxsize) {
  if (ws->sleeptime!=0)
    usleep(ws->sleeptime);
  if (maxsize>ws->returnsize)
    return ws->returnsize;
  else
    return maxsize;
}
