#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "TCPCLIENT ACQ_PLUGIN TESTS"
echo
rm -rf /tmp/tcpc_unit_test
mkdir /tmp/tcpc_unit_test
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_acq.xml > server.trace 2>&1 &
wait_until_awake localhost $ACQ_PORT
exec_n_test ./init.sh tcpcdummy 1 /opt/pyrame/tcpc_acq.so /opt/pyrame/uncap_dummy.so 127.0.0.1 5005 go 0 0 /tmp/tcpc_unit_test none
tcpc localhost $DATASTREAM_BASE_PORT > socket.trace &
./tcp_server.py &
exec_n_test ./startacq.sh tcpcdummy
exec_n_test ./stopacq.sh tcpcdummy
exec_n_test ./flush_files.sh tcpcdummy test none none none none none none
check_exist_file /tmp/tcpc_unit_test/test_tcpcdummy_0.raw
check_equal_files /tmp/tcpc_unit_test/test_tcpcdummy_0.raw raw.ref
check_equal_files socket.trace raw.ref
exec_n_test ./deinit.sh tcpcdummy

rm -rf /tmp/tcpc_unit_test
clean_all
echo "all tests passed"
