#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "TCPSERVER ACQ_PLUGIN TESTS"
echo
rm -rf /tmp/tcps_unit_test
mkdir /tmp/tcps_unit_test
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_acq.xml > server.trace 2>&1 &
wait_until_awake localhost $ACQ_PORT
exec_n_test ./init.sh  tcpsdummy 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so 8003 null null 0 0 /tmp/tcps_unit_test none
tcpc localhost $DATASTREAM_BASE_PORT > socket.trace &
exec_n_test ./startacq.sh tcpsdummy
echo TEST | tcpc localhost 8003 1
exec_n_test ./stopacq.sh tcpsdummy
exec_n_test ./flush_files.sh tcpsdummy test none none none none none none
check_exist_file /tmp/tcps_unit_test/test_tcpsdummy_0.raw
check_equal_files /tmp/tcps_unit_test/test_tcpsdummy_0.raw raw.ref
check_equal_files socket.trace raw.ref
exec_n_test ./deinit.sh tcpsdummy

rm -rf /tmp/tcps_unit_test
clean_all
echo "all tests passed"
