#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "UDP ACQ_PLUGIN TESTS"
echo
rm -rf /tmp/udp_unit_test
mkdir /tmp/udp_unit_test
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_acq.xml -d > server.trace 2>&1 &
wait_until_awake localhost $ACQ_PORT
exec_n_test ./add_udp_mono_control_test.sh umc1 2057
exec_n_test ./add_udp_mono_control_test.sh umc2 2064
exec_n_test ./add_udp_mono_data_test.sh umd 2065
tcpc localhost $((DATASTREAM_BASE_PORT+2)) > socket.trace &
exec_n_test ./startacq.sh umc1
exec_n_test ./startacq.sh umc2
exec_n_test ./startacq.sh umd
exec_n_test ./udp_sender.py 2065 TEST
exec_n_test ./stopacq.sh umc1
exec_n_test ./stopacq.sh umc2
exec_n_test ./stopacq.sh umd
exec_n_test ./startacq.sh umc1
exec_n_test ./startacq.sh umc2
exec_n_test ./startacq.sh umd
exec_n_test ./udp_sender.py 2057 AATEST
exec_n_test ./udp_sender.py 2064 ABTEST
exec_n_test ./stopacq.sh umc1
exec_n_test ./stopacq.sh umc2
exec_n_test ./stopacq.sh umd
exec_n_test ./flush_files.sh umc1 test none none none none none none 
exec_n_test ./flush_files.sh umc2 test none none none none none none 
exec_n_test ./flush_files.sh umd test none none none none none none
exec_n_test ./getstats.sh
# 16705 is 0x4141 (network order) = (unsigned short)("AA")
# 16706 is 0x4142 (network order) = (unsigned short)("AB")
exec_n_test ./get_ckpt_by_id.sh umc1 16705
exec_n_test ./get_ckpt_by_id.sh umc2 16706
check_exist_file /tmp/udp_unit_test/test_umd_0.raw
check_equal_files /tmp/udp_unit_test/test_umd_0.raw raw.ref
#TODO debug socket
#check_equal_files socket.trace raw.ref
exec_n_test ./deinit.sh umc1
exec_n_test ./deinit.sh umc2
exec_n_test ./deinit.sh umd


exec_n_test ./add_udp_multi_test.sh umt 2057:2064:2065
tcpc localhost $((DATASTREAM_BASE_PORT+3)) > socket.trace &
exec_n_test ./startacq.sh umt
exec_n_test ./udp_sender.py 2065 TEST
exec_n_test ./udp_sender.py 2057 AATEST
exec_n_test ./udp_sender.py 2064 ABTEST
exec_n_test ./stopacq.sh umt
sleep 1s
exec_n_test ./flush_files.sh umt test none none none none none none
exec_n_test ./getstats.sh
# 16705 is 0x4141 (network order) = (unsigned short)("AA")
# 16706 is 0x4142 (network order) = (unsigned short)("AB")
exec_n_test ./get_ckpt_by_id.sh umt 16705
exec_n_test ./get_ckpt_by_id.sh umt 16706
check_exist_file /tmp/udp_unit_test/test_umt_0.raw
check_equal_files /tmp/udp_unit_test/test_umt_0.raw raw.ref
check_equal_files socket.trace raw.ref
exec_n_test ./deinit.sh umt

rm -rf /tmp/udp_unit_test
clean_all
echo "all tests passed"
