#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all

echo
echo
echo "ACQ CORE TESTS"
echo
cmdmod /opt/pyrame/cmd_acq.xml > acq.trace 2>&1 &
cmdmod /opt/pyrame/cmd_varmod.xml -d > varmod.trace 2>&1 &
wait_until_awake localhost $ACQ_PORT
wait_until_awake localhost $VARMOD_PORT
exec_n_test chkpyr2.py localhost $ACQ_PORT init_acq test 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so 8003 null null 100000 0 /tmp /opt/pyrame/mv.py
#check for failure of creating a second acqunit with same name
exec_n_test_fail chkpyr2.py localhost $ACQ_PORT init_acq test 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so 8003 null null 100000 0 /tmp /opt/pyrame/mv.py

exec_n_test chkpyr2.py localhost $ACQ_PORT start_converter_acq test 0 /opt/pyrame/hle_decoder.so "a!b||" "a"
wait_until_awake localhost $CD_BASE_PORT
exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq test

for i in `seq 10`
do
    echo "injecting $i"
    echo ${i}'!11||' | tcpc localhost 8003 1
done

exec_n_test chkpyr2.py localhost $ACQ_PORT stop_acq test
exec_n_test chkpyr2.py localhost $ACQ_PORT flush_files_acq test crap "file:///" "/tmp" crap undef undef undef
exec_n_test chkpyr2.py localhost $ACQ_PORT deinit_acq test
exec_n_test chkpyr2.py localhost $ACQ_PORT init_acq test 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so 8003 null null 100000 0 /tmp /opt/pyrame/mv.py
exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq test
exec_n_test chkpyr2.py localhost $ACQ_PORT stop_acq test
exec_n_test chkpyr2.py localhost $ACQ_PORT flush_files_acq test crap "file:///" "/tmp" crap undef undef undef
exec_n_test chkpyr2.py localhost $ACQ_PORT deinit_acq test

clean_all
echo "all tests passed"
