#!/usr/bin/python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

import sys,os,bindpyrame

def mark_as_finished(storage_host,storage_id,acq_id,acq_name,acq_mp,acq_path):
    if storage_id=="undef" or acq_id=="undef":
        return
    storage_port=bindpyrame.get_port("STORAGE_PORT")
    retcode,res=bindpyrame.sendcmd(storage_host,storage_port,"mark_as_finished_storage",storage_id,acq_id,acq_name,acq_mp,acq_path)
    if retcode==0: 
        print("mv.py: error: marking %s as finished <- %s"%(acq_id,res))

#get the parameters
#print(sys.argv)
src_path=sys.argv[1].rstrip("/")
src_name=sys.argv[2]
acq_mp=sys.argv[3]
acq_path=sys.argv[4].rstrip("/")
acq_name=sys.argv[5]
acq_id=sys.argv[6]
storage_host=sys.argv[7]
storage_id=sys.argv[8]

#mount the nfs destination if necessary
mountd_port=bindpyrame.get_port("MOUNTD_PORT")
retcode,res=bindpyrame.sendcmd("localhost",mountd_port,"mount_mountd",acq_mp)
if retcode==0:
    print("ERROR cant mount destination %s <- %s"%(acq_mp,res))
    sys.exit(1)
acq_local_path=("%s/%s"%(res.rstrip("/"),acq_path)).replace("//","/")

#move the files
print("mv.py: moving from prefix=%s/%s to dest prefix=%s/%s"%(src_path,src_name,acq_local_path,acq_name))
os.system("mkdir -p %s"%(acq_local_path))
for suffix in sys.argv[9:]:
    src="%s/%s%s"%(src_path,src_name,suffix)
    dst="%s/%s%s"%(acq_local_path,acq_name,suffix)
    print("mv.py: moving %s to %s ..."%(src,dst))
    os.system("mv %s %s"%(src,dst))
    os.system("chmod a+r %s"%(dst))

#warn storage that mv is finished
mark_as_finished(storage_host,storage_id,acq_id,acq_name,acq_mp,acq_path)
