#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "CONVERT SCRIPTS TESTS: MV"
echo
rm -rf /tmp/convert_scripts_unit_test
mkdir /tmp/convert_scripts_unit_test
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_acq.xml > server.trace 2>&1 &
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_mountd.xml > mountd.trace 2>&1 &
wait_until_awake localhost $ACQ_PORT
wait_until_awake localhost $MOUNTD_PORT

rm -f /tmp/convert_scripts_unit_test/*
rm -rf /tmp/convert_scripts2_unit_test
mkdir /tmp/convert_scripts2_unit_test
exec_n_test ./init.sh noacq 1 /opt/pyrame/noacq_acq.so /opt/pyrame/uncap_dummy.so null null null 0 0 /tmp/convert_scripts_unit_test  /opt/pyrame/mv.py
exec_n_test ./inject_data.sh noacq 0 "84,79,84,79"
exec_n_test ./flush_files.sh noacq final "file:///" "tmp/convert_scripts2_unit_test" final_testmv undef undef undef
sleep 1s
check_exist_file /tmp/convert_scripts2_unit_test/final_testmv_noacq_0.raw
exec_n_test ./deinit.sh noacq

rm -rf /tmp/convert_scripts_unit_test
rm -rf /tmp/convert_scripts2_unit_test
clean_all
echo "all tests passed"
