/*
 * Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
 * This file is part of Pyrame.
 *
 * Pyrame is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pyrame is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
 * */

#include "../../libpyrame/pyrame.h"


int main(int argc,char **argv) {
  int streamid;
  struct shbuffer *shbuf;
  char buf[SHARED_BUFFER_SIZE+1];
  int size;
  
  //parse arguments
  if (argc<2) {
    printf("usage : %s streamid",argv[0]);
    exit(1);
  }

  streamid=atoi(argv[1]);
  shbuf=open_shbuffer(streamid,NO_CREATE,0);
  printf("reading the stream %d\n",streamid);
  ready_shbuffer(shbuf);
 
  //infinitely read and discard data from shmem
  while(1) {
    size=read_shbuffer(shbuf,buf);
    buf[size]=0;
    printf("read %d bytes : \n%s\n",size,buf);
  }
}
