/*
Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Pyrame.

Pyrame is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Pyrame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
*/

#include <Python.h>
#include "../libpyrame/pyrame.h"

static PyObject* open_socket_py(PyObject *self, PyObject *args);
static PyObject* get_port_py(PyObject *self, PyObject *args);
static PyObject* execcmd_py(PyObject *self, PyObject *args);
static PyObject* sendcmd_py(PyObject *self, PyObject *args);

static PyMethodDef bindpyrame_py_methods[]  =  {
  {"open_socket",open_socket_py,METH_VARARGS,"Open socket"},
  {"get_port",get_port_py,METH_VARARGS,"Get port in table"},
  {"execcmd",execcmd_py,METH_VARARGS,"Execute Pyrame command on given socket"},
  {"sendcmd",sendcmd_py,METH_VARARGS,"Send Pyrame command to host and port"},
  {NULL,  NULL,  0,  NULL}
};

