/*
Copyright 2012-2015 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Pyrame.

Pyrame is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Pyrame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
*/

function bindpyrame(xhr_host,xhr_port,onopen_handler) {
  /* Init */
  if (typeof XMLHttpRequest === "undefined") {
    alert("XMLHttpRequest NOT supported by your browser!");
    return;
  }

  this.url = "http://"+xhr_host+":"+xhr_port.toString()+"/pyrame_xhr";

  this.generic_receive_handler = function() {
    if (this.readyState !== XMLHttpRequest.DONE || this.status !== 200) {
      return;
    }
    if (typeof this.bindpyrame_handler === "function") {
      var args = [this.response["retcode"],this.response["res"]].concat(this.bindpyrame_data);
      this.bindpyrame_handler.apply(this,args);
    }
  }

  this.sendcmd = function(receive_handler, data, port, command) {
    xhr = new XMLHttpRequest();
    xhr.responseType="json";
    xhr.onreadystatechange = this.generic_receive_handler;
    xhr.bindpyrame_handler = receive_handler;
    xhr.bindpyrame_data = data;
    var i;
    var smsg = "host=localhost";
    smsg+="&port="+encodeURIComponent(port.toString());
    smsg+="&func="+encodeURIComponent(command);
    params_start = 4;
    for (i=0; i<arguments.length-params_start;i++)
      smsg+="&param"+(i+1)+"="+encodeURIComponent(arguments[i+params_start]);
    xhr.open("POST",this.url);
    xhr.send(smsg);
  };

  if (onopen_handler) {
    setTimeout(onopen_handler,0);
  }
}
