#ifndef CMDMOD_DISPATCH
#define CMDMOD_DISPATCH

struct cmdmod_ws;

struct circ_bl_elem {
  struct block *block;
  int nb_cs;
  struct circ_bl_elem *next;
};

struct dispatch_ws {
  struct netserv_workspace *netserv_ws;
  int dataport;
  int datareadyport;
  char *name;
  int mode; //0 online 1 offline
  int run_nb;
  int init_nb_cs;
  //circular block list
  struct circ_bl_elem *cbl;
  int cur_block;
  //events struct
  pthread_mutex_t *evt_mutex;
  struct evtstruct *schema;
  char *schema_str;
  struct netserv_client *data_ready_sockets;
  pthread_t t_serializer;
  sem_t sem_serializer;
};

int init_dispatcher(struct cmdmod_ws *ws,int nb_blocks,char *name,char *schema_str,char *port);
int flush_dispatcher(struct dispatch_ws *ws);
int insert_bl(struct dispatch_ws *ws,struct block *bl);
int finalize_bl(struct dispatch_ws *ws,struct block *bl);
int set_chans(struct dispatch_ws *ws,char *schema_str);

struct cmd_result *treat_get_blocklist(struct cmdmod_ws *ws,struct cmd *command);
struct cmd_result *treat_get_nextblock(struct cmdmod_ws *ws,struct cmd *command);
struct cmd_result *treat_get_block(struct cmdmod_ws *ws,struct cmd *command);
struct cmd_result *treat_smart_get_block(struct cmdmod_ws *cws,struct cmd *command);
struct cmd_result *treat_get_chans(struct cmdmod_ws *ws,struct cmd *command);
struct cmd_result *treat_register_consumer(struct cmdmod_ws *ws,struct cmd *command);

#endif
