
#ifndef CMDMOD_ENV_H
#define CMDMOD_ENV_H

#define ENV_STR 0
#define ENV_INT 1
#define ENV_FLOAT 2
#define ENV_NS 3

struct envrec {
  char *ns;
  char *param_name;
  char *param_value;
  char param_type;
  char synchro;
  char dirty;
  struct envrec *next;
  struct envrec *prev;
};

struct cenv {
  struct envrec *recs;
  int nbrecs;
  char registered;
  pthread_t *t_synchro;
  pthread_mutex_t *env_mutex;
};

struct cenv *new_cenv(void);

char *env_getvar(struct cenv *env,const char *ns,const char *name);
char env_gettype(struct cenv *env,const char *ns,const char *name);
int env_setvar(struct cenv *env,const char *ns,const char *name,char *value,char type,char synchro);
int env_delvar(struct cenv *env,const char *ns,const char *name);

char *env_dumpns(struct cenv *env,const char *ns);
int env_newns(struct cenv *env,const char *ns_name);
int env_checkns(struct cenv *env,const char *ns_name);
int env_delns(struct cenv *env,const char *ns_name);
char * env_listns(struct cenv *env);
 
void env_print(struct cenv *env);
int env_dump(struct cenv *env);
int env_load(struct cenv *env,char *filename);

void *thread_synchroenv(void *param);
#endif

