/*
Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Pyrame.

Pyrame is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Pyrame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
*/

#include "cmdmod.h"

struct cmd_result *submod_getmyport() {
  char *res_port=submod_getvar("system","listen_port");
  if (res_port==NULL) {
    return raw_build_result(0,"cant find listen_port in environment");
  } else {
    return raw_build_result(1,res_port);
  }
}

struct cmd_result *submod_setmyport(unsigned short myport) {
  int res;
  char *port=malloc(1024);
  sprintf(port,"%d",myport);
  res=submod_setvar("system","listen_port",port,ENV_INT);
  if (res==0) {
    return raw_build_result(0,"cant set listen_port in environment");
  } else {
    return raw_build_result(1,"ok");
  }
}

struct cmd_result *submod_getmyfile() {
  char *res=submod_getvar("system","code_file_name");
  if (res==NULL) {
    return raw_build_result(0,"cant find code_file_name in environment");
  } else {
    return raw_build_result(1,res);
  }
}
