submod_execcmd=submod.execcmd
submod_getport=submod.getport
submod_exit=submod.exit

def init():
    #print("generic init function")
    pass

def deinit():
    #print("generic deinit function")
    pass

#THREADS
def submod_bgcontext():
    return submod.callwrap("bgcontext")

def submod_sendres(context,retcode,retstr):
    return submod.callwrap("sendres",context,str(retcode),retstr)

KEEPOPEN=3

#ENV
def submod_setvar(ns,name,value,vtype):
    return submod.callwrap("setvar",ns,name,value,vtype)

def submod_getvar(ns,name):
    return submod.callwrap("getvar",ns,name)

def submod_gettype(ns,name):
    return submod.callwrap("gettype",ns,name)

def submod_delvar(ns,name):
    return submod.callwrap("delvar",ns,name)

def submod_newns(ns):
    return submod.callwrap("newns",ns)

def submod_delns(ns):
    return submod.callwrap("delns",ns)

def submod_checkns(ns):
    return submod.callwrap("checkns",ns)

def submod_dumpns(ns):
    return submod.callwrap("dumpns",ns)

def submod_listns():
    return submod.callwrap("listns")

#DISPATCHER
def submod_init_dispatcher(nb_blocks,name,schema,port):
    return submod.callwrap("initdispatcher",str(nb_blocks),name,schema,port)
def submod_flush_dispatcher():
    return submod.callwrap("flushdispatcher")
def submod_new_block(block_id):
    return submod.callwrap("newblock",str(block_id))
def submod_new_event(block):
    return submod.callwrap("newevent",block)
def submod_set_field_block(block,field_name,value):
    return submod.callwrap("setfieldblock",block,field_name,value)
def submod_set_field_event(event,field_name,value):
    return submod.callwrap("setfieldevent",event,field_name,value)
def submod_finalize_block(block):
    return submod.callwrap("finalizeblock",block)
def submod_set_chans(schema):
    return submod.callwrap("setchans",schema)

#SYSTEM

def submod_setmyport(port):
    return submod_setvar("system","listen_port",str(port),"1")

def submod_getmyport():
    return submod_getvar("system","listen_port")

def submod_getmyfile():
    return submod_getvar("system","code_file_name")

def submod_wakemeup(time,func,param):
    return submod.callwrap("wakemeup",str(time),func,param)

def submod_setres(retcode,retstr):
    submod_setvar("system","retcode",str(retcode),"1")
    submod_setvar("system","retstr",retstr,"0")
    return 1,"ok"

def sbool(value):
    if value.lower() in ["true","1","on","yes"]:
        return 1
    return 0

def is_enabled(dev_name):
    retcode,res=submod_execcmd("is_enabled@cmod",dev_name)
    if retcode==0:
        raise Exception(res)
    if res=="1":
        return True
    else:
        return False

def iohtoi(string):
    if string[0:2]=="0x" or string[0:2]=="0X":
        return int(string,16)
    if string[0:2]=="0b" or string[0:2]=="0B":
        return int(string,2)
    if string[0:1]=="0":
        return int(string,8)
    return int(string)
