/*
Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Pyrame.

Pyrame is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Pyrame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
*/
#include <Python.h>
#include <frameobject.h>
#include "../libpyrame/pyrame.h"
#include "cmdmod.h"

#ifndef CMDMOD_PYTHON_H
#define CMDMOD_PYTHON_H

struct python_ws {
  int id;
  PyObject* main;
  PyObject* dict;
  PyThreadState *_save;
  struct cmdmod_ws *cws;
};


static PyObject *submod_execcmd_python(PyObject *self,PyObject *args);
static PyObject *submod_exit_python(PyObject *self,PyObject *args);
static PyObject *submod_getport_python(PyObject *self,PyObject *args);
static PyObject* submod_callwrap_python(PyObject *self,PyObject *args);

static PyMethodDef submodmethods[] = {
    {"execcmd",submod_execcmd_python,METH_VARARGS,"Sub-module execution"},
    {"exit",submod_exit_python,METH_VARARGS,"pyrame clean exiting"},
    {"getport",submod_getport_python,METH_VARARGS,"get port from db"},
    {"callwrap",submod_callwrap_python,METH_VARARGS,"execute a call to cmdmod wrappers"},
    {NULL,  NULL,  0,  NULL}
};
#endif
