#include <cmd_converter.h>


int request_new_data(struct conv_ws *ws,char * buffer) {
  int rsize;
  //printf("request new data\n");
  switch(ws->itype) {
  case SHMEM:
    //printf("reading from shmem %d\n",ws->shbuf->portid);
    rsize=read_shbuffer(ws->shbuf,buffer);
    //printf("done\n");
    if (rsize<=0) {
      return 0;
    } else {
      //printf("returned %d bytes\n",rsize);
      return rsize;
    }
    break;
  case TCP:
    //printf("reading from socket\n");
    rsize=read(ws->data_socket,buffer,SHARED_BUFFER_SIZE);
    if (rsize<=0) {
      return EBROK;
    } else {
      //printf("returned %d bytes\n",rsize);
      return rsize;
    }
    break;
  case OFILE:
    //printf("reading from file\n");
    usleep(1000);
    rsize=fread(buffer,1,1000,ws->finput);
    //rsize=fread(buffer,1,SHARED_BUFFER_SIZE,ws->finput);
    if (rsize==0)
      return EBROK;
    else
      return rsize;
    break;
  case UNKNOWN:
    break;
  default:
    break;
  }
  printf("unknown input type\n");
  return -1;
}



void update_clock(struct conv_ws *ws,char * new_clock) {
  if (ws->clock!=NULL) {
    free(ws->clock);
  }
  ws->clock=new_clock;
  if (ws->clock_socket!=-1) {
    write(ws->clock_socket,ws->clock,strlen(ws->clock));
  }
}
