
#include <pyrame.h>

int main(int argc,char **argv) {
  int socket;
  int index=0;
  int res;
  char buffer[1024];
  int i;

  
  if (argc<3) {
    printf("usage : %s spill_nb packet_nb\n",argv[0]);
    exit(1);
  }

  //create buffer
  
  for(i=0;i<12;i++) { //ethernet header
    buffer[index+i]=0;
  }
  *(unsigned short*)(buffer+index+12)=htons(0x811);
  index+=14;
  
  for(i=0;i<10;i++) { //gdcc header
    buffer[index+i]=0;
  }
  *(unsigned short*)(buffer+index+10)=atoi(argv[2]);
  *(unsigned short*)(buffer+index+12)=1;
  buffer[index+14]=0;
  buffer[index+15]=0;
  index+=16;
  
  
  buffer[index]=0xfc; //spill start header
  buffer[index+1]=0xff;
  buffer[index+2]=0; //spill in reverse
  buffer[index+3]=0;
  buffer[index+4]=atoi(argv[1]);
  buffer[index+5]=0; //high part of spill nb
  buffer[index+6]=0x53; //S
  buffer[index+7]=0x50; //P
  buffer[index+8]=0x49; //I
  buffer[index+9]=0x4c; //L
  buffer[index+10]=0x20; // space
  buffer[index+11]=0x20; // space
  index+=12;


  buffer[index]=0xfd; //chip start header
  buffer[index+1]=0xff;
  buffer[index+2]=1; //chip number
  buffer[index+3]=0xff; //alignment
  buffer[index+4]=0x43; //C
  buffer[index+5]=0x48; //H
  buffer[index+6]=0x49; //I
  buffer[index+7]=0x50; //P
  buffer[index+8]=0x20; //space
  buffer[index+9]=0x20; //space
  index+=10;

  for(i=0;i<64;i++) { //gain 0 hit for 0
    if (i==0 || i==63) 
      buffer[index+i*2+1]=16;
    else
      buffer[index+i*2+1]=0;
    buffer[index+i*2]=i;
  }
  index+=128;
  
  for(i=0;i<64;i++) {//gain 1 hit for 0
    if (i==0 || i==63)
      buffer[index+i*2+1]=48;
    else
      buffer[index+i*2+1]=32;
    buffer[index+i*2]=2*i;
  }
  index+=128;

  
  
  buffer[index]=10;//bcid
  buffer[index+1]=0;
  index+=2;
  
  buffer[index]=14; //chip id 14
  buffer[index+1]=0; //chip id
  index+=2;

  buffer[index]=0xfe; //chip stop header
  buffer[index+1]=0xff;
  buffer[index+2]=1; //chip number
  buffer[index+3]=0xff; //alignment
  buffer[index+4]=0x20; //space
  buffer[index+5]=0x20; //space
  buffer[index+6]=0x20; //space
  buffer[index+7]=0x20; //space
  index+=8;
  

  buffer[index]=0xff; //spill stop header
  buffer[index+1]=0xff;
  buffer[index+2]=0; //spill in reverse
  buffer[index+3]=0;
  buffer[index+4]=atoi(argv[1]);
  buffer[index+5]=0; //high part of spill nb
  buffer[index+6]=0; //6 zeros
  buffer[index+7]=0;
  buffer[index+8]=0;
  buffer[index+9]=0;
  buffer[index+10]=0; 
  buffer[index+11]=0;
  buffer[index+12]=0x20; // space
  buffer[index+13]=0x20; // space
  buffer[index+14]=0xff; //false CRC
  buffer[index+15]=0xff; //false CRC
  index+=16;

  //dif trailer
  buffer[index]=0; 
  buffer[index+1]=0;
  index+=2;
  
  socket=open_socket("localhost",8003);
  if (socket==-1) {
    printf("cant open socket...exiting\n");
    exit(1);
  }

  printf("writing %d bytes in socket\n",index);
  res=write(socket,buffer,index);
  if (res!=index) {
    printf("error in writing (%d)\n",res);
    perror("write");
  }
  close(socket);
}

