#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "../cmd_converter.h"

int create_block(struct conv_ws *ws,int index) {
  int i;
  int res;
  struct block *b;
  struct event *e;
  struct evtstructelem *ese_p1,*ese_p2,*ese_p3;
  struct evtstructelem *ese_t1,*ese_t2;
  struct evtstructelem *ese_s1,*ese_s2,*ese_s3,*ese_s4;
  struct evtstructelem *ese_d1,*ese_d2;
  res=submod_new_block(index,&b);
  if (res<0) {
    printf("desynchronization...exiting\n");
    exit(1);
  }

  ese_p1=get_ese(ws->schema,"p1");
  ese_p2=get_ese(ws->schema,"p2");
  ese_p3=get_ese(ws->schema,"p3");
  ese_t1=get_ese(ws->schema,"t1");
  ese_t2=get_ese(ws->schema,"t2");
  ese_s1=get_ese(ws->schema,"s1");
  ese_s2=get_ese(ws->schema,"s2");
  ese_s3=get_ese(ws->schema,"s3");
  ese_s4=get_ese(ws->schema,"s4");
  ese_d1=get_ese(ws->schema,"d1");
  ese_d2=get_ese(ws->schema,"d2");

  submod_set_field_block(b,ese_p1,"1");
  submod_set_field_block(b,ese_p2,"2");
  submod_set_field_block(b,ese_p3,"3");
  set_stats(ws->stats,"nb_blocks",SOP_PLUS,1.0);

  for(i=0;i<5;i++) {
    res=submod_new_event(b,&e);
    if (res<0) {
      printf("cant create event\n");
      exit(1);
    }
    submod_set_field_event(e,ese_t1,"1");
    submod_set_field_event(e,ese_t2,"2");
    submod_set_field_event(e,ese_s1,"1");
    submod_set_field_event(e,ese_s2,"2");
    submod_set_field_event(e,ese_s3,"3");
    submod_set_field_event(e,ese_s4,"4");
    submod_set_field_event(e,ese_d1,"1");
    submod_set_field_event(e,ese_d2,"2");
    set_stats(ws->stats,"nb_events",SOP_PLUS,1.0);
  }
  submod_finalize_block(b);
  return 0;
}
      
void finalize(struct conv_ws *ws) {
  printf("no more data...finalizing\n");
  while(1) {
    usleep(100000000);
    printf("decoder finalized\n");
  }
}

void init_plugin(void *vdata) {
  //global workspace herited from converter/dispatcher
  struct conv_ws *ws=vdata;

  ws->sws=NULL;
  ws->schema_str=strdup("p1,p2,p3!t1,t2|s1,s2,s3,s4|d1,d2");

  //initialize the stats system
  add_acc(ws->stats,"nb_blocks",0);
  add_acc(ws->stats,"nb_events",0);
}

void convert(void *vdata) {
  struct conv_ws *ws=vdata;
  int i;
  for(i=0;i<10;i++) {
    create_block(ws,i);
  }
  finalize(ws);
}
