#ifndef SKIROC_ROOTANA_H
#define SKIROC_ROOTANA_H

// ROOT classes
#include <TApplication.h>
#include <TROOT.h> 
#include <TStyle.h>
#include <TFile.h>
#include <TTree.h>
#include <TString.h>

// C++
#include <iostream>
#include <fstream>
#include <string>

#define MEMDEPTH 13
#define NCHANNELS 64
using namespace std;

class ROOTana {
public:
   ROOTana();
   ~ROOTana();

   void StartEvent( int , int);
   void AddSCA( int, int, int* ,int* ,int );
   void AddTiming( int, int*, int*, int*, int*);
   void AddHit( int, int*, int*, int*, int*);
   void FillEvent();
   void Save( TString );
   
private:
   
   void SetTreeBranches();
   void ResetData( int , int );
   
   // TFile
   TFile *fout;
   
   // TTree
   TTree *tree;
   
   // TTree branches
   int EventNumber;
   int ChipId;
   int BunchCrossingId;
   
   int TOT_Fast[NCHANNELS];
   int TOT_Slow[NCHANNELS];
   int TOA_Rising[NCHANNELS];
   int TOA_Falling[NCHANNELS];
   
   int Hit_TOT_Fast[NCHANNELS];
   int Hit_TOT_Slow[NCHANNELS];
   int Hit_TOA_Rising[NCHANNELS];
   int Hit_TOA_Falling[NCHANNELS];
   
   int RollPosition[MEMDEPTH];
   int HG_Charge[MEMDEPTH][NCHANNELS];
   int LG_Charge[MEMDEPTH][NCHANNELS];
   
   // Others
   TString name;
};

#endif
