//
// Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
//

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <cmd_converter.h>

#define NB_SCA 16

#define loss_code         0xfffa
#define start_spill_code  0xfffc
#define stop_spill_code   0xffff
#define spill_header      "\xfc\xff"
#define spill_trailer     "\xff\xff"
#define start_chip_code   0xfffd
#define stop_chip_code    0xfffe
#define chip_trailer      "\xfe\xff"


//errors
#define hitbit_error 1
#define frontbit_error 2

//tags
#define bxpn_tag 1
#define plane_tag 2
#define underflow_tag 4
#define overflow_tag 8


struct map_cell {
  int c;
  int l;
  int x;
  int y;
} mapcell;

struct skiroc_ws {
  unsigned int current_spill;
  unsigned int current_chip;
  unsigned int spill_offset;
  unsigned int spill_cumul;
  int dif;
  struct block *block;
  struct evtstructelem *ese_spill,*ese_p,*ese_z;
  struct evtstructelem *ese_bcid,*ese_time;
  struct evtstructelem *ese_roc,*ese_chan,*ese_c,*ese_l,*ese_x,*ese_y;
  struct evtstructelem *ese_hit,*ese_en,*ese_en2;
  struct evtstructelem *ese_tag, *ese_sca, *ese_error;

  //ref parameters
  int ref;

  //cut non hit parameters
  int cut_non_hit;

  //cut parameters
  int bxpn_thresh; //remove recursively retriggering if bx<bx_prec+bxpn_thresh
  int plane_thresh; //remove plane event if nb_events>plane_thresh
  int cut_wrong_events; //remove events with error or tag

  //time conversion parameters
  float spill_period; //time=spill*spill_period+bx*bx_period
  float bx_period;

  //coordinate conversion parameters
  char *mapping_filename;
  float offset_x;
  float offset_y;
  float offset_z;
  int plan;

  //remove bad roc id
  int max_roc;

  //chan-roc/x-y mapping
  struct map_cell **mapping;
};
