//
// Copyright 2012-2014 Frédéric Magniette, Miguel Rubio-Roy, LLR
//

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <cmd_converter.h>

#define NB_SCA 16
#define CHAN_NB 36

#define loss_code         0xfffa
#define spill_nb_code     0xfffb
#define spill_nb_str      "\xfb\xff"
#define start_spill_code  0xfffc
#define start_spill_str   "\xfc\xff"
#define stop_spill_code   0xffff
#define stop_spill_str    "\xff\xff"
#define start_chip_code   0xfffd
#define start_chip_str    "\xfd\xff"
#define stop_chip_code    0xfffe
#define stop_chip_str  "\xfe\xff"

struct map_cell {
  int plane;
  int channel;
  float x;
  float y;
  float z;
} mapcell;

struct spiroc_ws {
  int current_spill;
  int block_cnt;
  unsigned short current_spill_flag;
  unsigned int current_chip;
  unsigned int spill_offset;
  unsigned int spill_cumul;
  int dif;
  struct block *block;
  struct evtstructelem *ese_spill,*ese_spill_flag;
  struct evtstructelem *ese_sca,*ese_bcid,*ese_time;
  struct evtstructelem *ese_roc,*ese_rocchan,*ese_plane,*ese_channel;
  struct evtstructelem *ese_x,*ese_y,*ese_z;
  struct evtstructelem *ese_hit,*ese_en,*ese_gain;

  //ref parameters
  int ref;

  //cut non hit parameters
  int cnh;

  //cut parameters
  int min_energy; //remove too small energy if en1<min_energy || en2<min_energy

  //time conversion parameters
  float spill_period; //time=spill*spill_period+bx*bx_period
  float bx_period;

  //coordinate conversion parameters
  char *mapping_filename;
  float offset_x;
  float offset_y;
  float offset_z;
  int plan;

  //remove bad roc id
  int max_roc;

  //chan-roc/x-y mapping
  struct map_cell **mapping;
};
