/*
Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Pyrame.

Pyrame is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Pyrame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
*/

#include "cmd_converter.h"

int main(int argc,char **argv) {
  
  //init the workspace
  struct conv_ws * ws=(struct conv_ws *)malloc(sizeof(struct conv_ws));
  bzero(ws,sizeof(struct conv_ws));

  //extract parameters from command line
  if (argc!=2) {
    printf("usage : %s filename\n",argv[0]);
    exit(1);
  }

  ws->itype=OFILE;
  ws->output_mode=OFFLINE;
  ws->filename=strdup(argv[1]);
  
  ws->finput=fopen(ws->filename,"r");
  if (ws->finput==NULL) {
    printf("unable to open file %s...exiting\n",ws->filename);
    exit(1);
  }

  //call the plugin
  init_plugin(ws);
  convert((void *)ws);

  return 0;
}

int submod_init_dispatcher(int nb_blocks,char *name,char *schema_str,char *port){ return 0; }
int submod_flush_dispatcher(void){ return 0; }
int submod_new_block(int block_id,struct block **result){ return 0; }
int submod_new_event(struct block *bl,struct event **result){ return 0; }
void submod_add_block(struct block *bl,int block_id){}
int submod_set_field_block(struct block *bl,struct evtstructelem *ese,char *format,...){ return 0; }
int submod_set_field_event(struct event *ev,struct evtstructelem *ese,char *format,...){ return 0; }
int submod_finalize_block(struct block *bl){ return 0; }
int submod_set_chans(char *schema_str){ return 0; }


