#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all

echo
echo
echo "HLE CONVERTER TESTS"
echo
cmdmod /opt/pyrame/cmd_acq.xml -d > acq.trace 2>&1 &
cmdmod /opt/pyrame/cmd_varmod.xml > varmod.trace 2>&1 &
wait_until_awake localhost $ACQ_PORT
wait_until_awake localhost $VARMOD_PORT
exec_n_test chkpyr2.py localhost $ACQ_PORT init_acq test 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so 8003 null null 100000 0 /tmp /opt/pyrame/mv.py
exec_n_test chkpyr2.py localhost $ACQ_PORT start_converter_acq test 0 /opt/pyrame/hle_decoder.so "a!b|c|d" "a"
sleep 1
wait_until_awake localhost $CD_BASE_PORT
exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq test
checkretstr "" ./get_block_list.sh ${CD_BASE_PORT} 0
exec_n_test_retcode -2 ./smart_get_block.sh ${CD_BASE_PORT} 0 f 0
RUN_NB=$RETSTR
echo "new run nb = $RUN_NB"
exec_n_test_retcode -1 ./smart_get_block.sh ${CD_BASE_PORT} $RUN_NB f 0
echo '1!1|2|3' | tcpc localhost 8003 1
checkretstr '1,1!1|2|3' ./smart_get_block.sh ${CD_BASE_PORT} $RUN_NB f 0
exec_n_test_retcode -1 ./smart_get_block.sh ${CD_BASE_PORT} $RUN_NB f 1
exec_n_test_retcode -1 ./smart_get_block.sh ${CD_BASE_PORT} $RUN_NB f 2
exec_n_test_retcode -1 ./smart_get_block.sh ${CD_BASE_PORT} $RUN_NB e 0
checkretstr '1,1!1|2|3' ./smart_get_block.sh ${CD_BASE_PORT} $RUN_NB e 1
exec_n_test_retcode -1 ./smart_get_block.sh ${CD_BASE_PORT} $RUN_NB e 2
checkretstr '1,1!1|2|3' ./smart_get_block.sh ${CD_BASE_PORT} $RUN_NB l 0
exec_n_test_retcode -1 ./smart_get_block.sh ${CD_BASE_PORT} $RUN_NB l 1
exec_n_test_retcode -1 ./smart_get_block.sh ${CD_BASE_PORT} $RUN_NB l 2
echo '2!2|4|6' | tcpc localhost 8003 1
echo '3!3|6|9' | tcpc localhost 8003 1
echo '2!2|4|6' | tcpc localhost 8003 1
sleep 1
checkretstr "1,2,3" ./get_block_list.sh ${CD_BASE_PORT} 0
checkretstr '1!1|2|3' ./get_block.sh ${CD_BASE_PORT} 1
exec_n_test_fail ./get_block.sh ${CD_BASE_PORT} 0
exec_n_test_fail ./get_block.sh ${CD_BASE_PORT} 4
exec_n_test chkpyr2.py localhost $ACQ_PORT stop_acq test
exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq test
sleep 1s
checkretstr "" ./get_block_list.sh ${CD_BASE_PORT} 0
exec_n_test_fail ./get_block.sh ${CD_BASE_PORT} 1
echo '1!1|2|3!4|5|6' | tcpc localhost 8003 1
checkretstr '1!1|2|3!4|5|6' ./get_block.sh ${CD_BASE_PORT} 1
exec_n_test chkpyr2.py localhost $ACQ_PORT stop_acq test
exec_n_test chkpyr2.py localhost $ACQ_PORT deinit_acq test
#cp acq.trace hle_trace.txt
clean_all

## DISABLE SKIROC TESTS UNTIL NOT DEPENDANT ON CALICOES
if test ! -f /opt/calicoes/uncap_dif4_1.so ; then exit 0; fi

echo
echo
echo "SKIROC CONVERTER TESTS"
echo
cmdmod /opt/pyrame/cmd_acq.xml > acq.trace 2>&1 &
cmdmod /opt/pyrame/cmd_varmod.xml > varmod.trace 2>&1 &
wait_until_awake localhost $ACQ_PORT
wait_until_awake localhost $VARMOD_PORT
exec_n_test chkpyr2.py localhost $ACQ_PORT init_acq ecal_dif 1 /opt/pyrame/tcps_acq.so /opt/calicoes/uncap_dif4_1.so 8003 null null 100000 0 /tmp /opt/pyrame/mv.py
exec_n_test chkpyr2.py localhost $ACQ_PORT start_converter_acq ecal_dif 0 /opt/pyrame/skiroc_decoder.so 0 1 4 10 10 1e6 0.4 /opt/calicoes/mapping_ecal_fev10.txt 0 0 0 0 16
sleep 1
wait_until_awake localhost $CD_BASE_PORT
exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq ecal_dif
wait_until_awake localhost 8003
checkretstr "" ./get_block_list.sh ${CD_BASE_PORT} 0
./plugins/gener_spill 6 1
./plugins/gener_spill 7 2
sleep 1
checkretstr "6,7" ./get_block_list.sh ${CD_BASE_PORT} 0
checkretstr '6,0,0.000000!10,6000004.0000000596|14,0,24,23,47.000000,42.000000|1,63,126' ./get_block.sh ${CD_BASE_PORT} 6
exec_n_test chkpyr2.py localhost $ACQ_PORT stop_acq ecal_dif
exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq ecal_dif
sleep 1s
./plugins/gener_spill 1 1
./plugins/gener_spill 2 2
./plugins/gener_spill 3 3
./plugins/gener_spill 4 4
./plugins/gener_spill 5 5
./plugins/gener_spill 3 6
sleep 1
checkretstr "1,2,3,4,5" ./get_block_list.sh ${CD_BASE_PORT} 0
checkretstr '1,0,0.000000!10,1000004.0000000596|14,0,24,23,47.000000,42.000000|1,63,126' ./get_block.sh ${CD_BASE_PORT} 1
exec_n_test chkpyr2.py localhost $ACQ_PORT stop_acq ecal_dif
exec_n_test chkpyr2.py localhost $ACQ_PORT deinit_acq ecal_dif
#cp acq.trace skiroc_trace.txt

clean_all
echo "all tests passed"
