#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all

echo
echo
echo "DP TESTS"
echo
. /opt/root/bin/thisroot.sh
cmdmod /opt/pyrame/cmd_dp.xml -d > cmd_dp.trace 2>&1 &
cmdmod /opt/pyrame/cmd_acq.xml -d > acq.trace 2>&1 &
cmdmod /opt/pyrame/cmd_varmod.xml -d > varmod.trace 2>&1 &
wait_until_awake localhost $DP_PORT
wait_until_awake localhost $ACQ_PORT
wait_until_awake localhost $VARMOD_PORT
exec_n_test chkpyr2.py localhost $ACQ_PORT init_acq test1 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so 8003 null null 100000 0 /tmp none
exec_n_test chkpyr2.py localhost $ACQ_PORT init_acq test2 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so 8004 null null 100000 0 /tmp none
exec_n_test chkpyr2.py localhost $ACQ_PORT start_converter_acq test1 0 /opt/pyrame/hle_decoder.so 'a!b|c|d' "a"
exec_n_test chkpyr2.py localhost $ACQ_PORT start_converter_acq test2 0 /opt/pyrame/hle_decoder.so '!time||rpm,temp' undef
exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq test1
exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq test2
wait_until_awake localhost $CD_BASE_PORT
wait_until_awake localhost `expr $CD_BASE_PORT + 1`
echo '1!1|2|3'   | tcpc localhost 8003 1
echo '2!3|4|6'   | tcpc localhost 8003 1
echo '3!5|6|9'   | tcpc localhost 8003 1
echo '4!7|8|12'  | tcpc localhost 8003 1
echo '5!9|10|15' | tcpc localhost 8003 1
echo '6!9|12|18' | tcpc localhost 8003 1
echo '7!9|14|21' | tcpc localhost 8003 1
echo  '!1||90000,25.0' | tcpc localhost 8004 1
echo  '!2||90010,25.1' | tcpc localhost 8004 1
echo  '!3||90011,25.2' | tcpc localhost 8004 1
echo  '!4||90012,25.1' | tcpc localhost 8004 1
echo  '!5||90012,25.0' | tcpc localhost 8004 1
echo  '!6||90013,24.9' | tcpc localhost 8004 1
echo  '!7||90013,24.8' | tcpc localhost 8004 1
echo  '!8||90013,24.7' | tcpc localhost 8004 1
echo  '!9||90014,24.8' | tcpc localhost 8004 1
echo '!10||90015,24.9' | tcpc localhost 8004 1
echo '!11||90018,25.0' | tcpc localhost 8004 1
echo '!12||90019,25.0' | tcpc localhost 8004 1
sleep 0.5s
checkretstr "1,2,3,4,5,6,7" ./get_block_list.sh ${CD_BASE_PORT} 0
checkretstr "1,2,3,4,5,6,7,8,9,10,11,12" ./get_block_list.sh `expr $CD_BASE_PORT + 1` 0

checkretstr 0 ./new_plot.sh converter_test1_0 "b" b undef undef histo
checkretstr "b" ./list_plots.sh
checkretstr 1 ./new_plot.sh converter_test1_0 "value of b" b undef undef label
checkretstr "b,value of b" ./list_plots.sh
for i in `seq 5`; do exec_n_test ./onestep.sh; done
checkretstr 2 ./new_plot.sh converter_test1_0 "a(d)" d a undef graph
checkretstr "b,value of b,a(d)" ./list_plots.sh
for i in `seq 5`; do exec_n_test ./onestep.sh; done
checkretstr 3 ./new_plot.sh converter_test2_0 "temp(time)" time temp undef graph
checkretstr "b,value of b,a(d),temp(time)" ./list_plots.sh
for i in `seq 5`; do exec_n_test ./onestep.sh; done
exec_n_test ./rewind.sh
for i in `seq 5`; do exec_n_test ./onestep.sh; done
exec_n_test ./del_plot.sh 3
checkretstr "b,value of b,a(d)" ./list_plots.sh
for i in `seq 5`; do exec_n_test ./onestep.sh; done
exec_n_test ./rewind.sh
for i in `seq 5`; do exec_n_test ./onestep.sh; done
exec_n_test ./del_plot.sh 0
checkretstr "value of b,a(d)" ./list_plots.sh
for i in `seq 5`; do exec_n_test ./onestep.sh; done
exec_n_test ./del_plot.sh 1
checkretstr "a(d)" ./list_plots.sh
checkretstr 3 ./new_plot.sh converter_test2_0 "rpm" rpm undef undef histo
checkretstr "a(d),rpm" ./list_plots.sh
checkretstr 4 ./new_plot.sh converter_test2_0 "value of rpm" rpm undef undef label
checkretstr "a(d),rpm,value of rpm" ./list_plots.sh
exec_n_test ./add_filter.sh 3 'rpm<90015'
exec_n_test ./add_filter.sh 3 'rpm>90010'
exec_n_test ./run.sh
exec_n_test ./stop.sh
exec_n_test ./del_filters.sh 3
exec_n_test ./rewind.sh
for i in `seq 5`; do exec_n_test ./onestep.sh; done
exec_n_test ./del_plot.sh 2
checkretstr "rpm,value of rpm" ./list_plots.sh
for i in `seq 5`; do exec_n_test ./onestep.sh; done
exec_n_test_fail ./del_plot.sh 1
for i in `seq 5`; do exec_n_test ./onestep.sh; done
exec_n_test_fail ./del_plot.sh 2
for i in `seq 5`; do exec_n_test ./onestep.sh; done
exec_n_test ./del_plot.sh 3
exec_n_test ./del_plot.sh 4
checkretstr "" ./list_plots.sh

clean_all
echo "all tests passed"
