/*
 * Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
 * This file is part of Pyrame.
 *
 * Pyrame is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pyrame is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
 * */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>
#include <cmdmod_helper.h>

#define BLOCK_NB 10000

struct evb_workspace {
  //cmod
  char *cmod_id;

  //command
  int command;
  
  //data
  int initialized;
  int *data_sockets;
  int nb_data_clients;
  int acquiring;

  //data ready
  int *dr_sockets;

  //evt structs
  struct evtstruct **es;
  
  //threads
  pthread_t t_manager;

  //external library
  void *lib_phy;
  char (*cut)(struct block *,char *,char *,char *);

  //cut arguments
  char *cutarg1;
  char *cutarg2;
  char *cutarg3;

  char *choice_field;
  float tolerance;

  //output
  int block_cnt;
  struct evtstruct *output_es;

  //stats
  struct stats_ws *stats;
};

void *manager(void *args);
void *converter(void *args);
