#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all

echo
echo
echo "EVB TESTS"
echo
cmdmod /opt/pyrame/cmd_acq.xml -d > acq.trace 2>&1 &
cmdmod /opt/pyrame/cmd_varmod.xml -d > varmod.trace 2>&1 &
cmdmod /opt/pyrame/cmd_evb.xml -d > evb.trace 2>&1 &
wait_until_awake localhost $ACQ_PORT
wait_until_awake localhost $VARMOD_PORT
wait_until_awake localhost $EVB_PORT

exec_n_test chkpyr2.py localhost $ACQ_PORT init_acq test1 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so 8003 null null 100000 0 /tmp none
exec_n_test chkpyr2.py localhost $ACQ_PORT init_acq test2 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so 8004 null null 100000 0 /tmp none
exec_n_test chkpyr2.py localhost $ACQ_PORT init_acq test3 1 /opt/pyrame/tcps_acq.so /opt/pyrame/uncap_dummy.so 8005 null null 100000 0 /tmp none

exec_n_test chkpyr2.py localhost $ACQ_PORT start_converter_acq test1 0 /opt/pyrame/hle_decoder.so "a!b||" "a"
exec_n_test chkpyr2.py localhost $ACQ_PORT start_converter_acq test2 0 /opt/pyrame/hle_decoder.so "a!b||" "a"
exec_n_test chkpyr2.py localhost $ACQ_PORT start_converter_acq test3 0 /opt/pyrame/hle_decoder.so "a!b||" "a"

wait_until_awake localhost $CD_BASE_PORT
wait_until_awake localhost `expr $CD_BASE_PORT + 1`
wait_until_awake localhost `expr $CD_BASE_PORT + 2`

exec_n_test chkpyr2.py localhost $EVB_PORT init_evb undef convert undef "a" "5" '!a,b||' 0 0 0 varmod


exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq test1
exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq test2
exec_n_test chkpyr2.py localhost $ACQ_PORT start_acq test3
exec_n_test chkpyr2.py localhost $EVB_PORT start_acq_evb

echo '1!11||' | tcpc localhost 8003 1
echo '3!13||' | tcpc localhost 8003 1
echo '4!14||' | tcpc localhost 8003 1
echo '7!17||' | tcpc localhost 8003 1

echo '1!21||' | tcpc localhost 8004 1
echo '2!22||' | tcpc localhost 8004 1
echo '4!24||' | tcpc localhost 8004 1
echo '7!27||' | tcpc localhost 8004 1

echo '1!31||' | tcpc localhost 8005 1
echo '2!32||' | tcpc localhost 8005 1
echo '5!35||' | tcpc localhost 8005 1
echo '7!37||' | tcpc localhost 8005 1

sleep 1s
exec_n_test chkpyr2.py localhost $ACQ_PORT stop_acq test1
exec_n_test chkpyr2.py localhost $ACQ_PORT stop_acq test2
exec_n_test chkpyr2.py localhost $ACQ_PORT stop_acq test3
exec_n_test chkpyr2.py localhost $EVB_PORT stop_acq_evb
checkretstr "0,1,2,3" chkpyr2.py localhost $EVB_PORT getblocklist_module -1
checkretstr '!1,11||!1,31||!1,21||' chkpyr2.py localhost $EVB_PORT getblock_module 0
checkretstr '!2,32||!2,22||' chkpyr2.py localhost $EVB_PORT getblock_module 1
checkretstr '!4,14||!4,24||' chkpyr2.py localhost $EVB_PORT getblock_module 2
checkretstr '!7,17||!7,37||!7,27||' chkpyr2.py localhost $EVB_PORT getblock_module 3
exec_n_test chkpyr2.py localhost $ACQ_PORT deinit_acq test1
exec_n_test chkpyr2.py localhost $ACQ_PORT deinit_acq test2
exec_n_test chkpyr2.py localhost $ACQ_PORT deinit_acq test3
exec_n_test chkpyr2.py localhost $EVB_PORT deinit_evb


clean_all
echo "all test passed"
