#!/bin/bash
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.

AUTOLAUNCHER=`ps -ef | grep "python2 /usr/local/bin/autolauncher.py" | grep -v grep | awk '{ print $2 }'`
if test "$AUTOLAUNCHER" != ""; then
  kill -9 $AUTOLAUNCHER > /dev/null 2>&1
  echo "KILLED autolauncher"
else
  echo "no autolauncher running"
fi


AUTOLAUNCHER_LOG=`ps -ef | grep "tail -f /tmp/autolauncher.log" | grep -v grep | awk '{ print $2 }'`
if test "$AUTOLAUNCHER_LOG" != ""; then
  kill -9 $AUTOLAUNCHER_LOG > /dev/null 2>&1
  echo "KILLED autolauncher logger"
else
  echo "no autolauncher logger running"
fi


killall -9 cmdmod > /dev/null 2>&1
if test $? -eq 1; then
  echo "no cmdmod running"
else
  echo "KILLED cmdmod"
fi


killall -9 tcpc > /dev/null 2>&1
if test $? -eq 1; then
  echo "no tcpc running"
else
  echo "KILLED tcpc"
fi

for i in `ps auxww | grep valgrind | awk '{ print $2 }'`
do
  kill $i > /dev/null 2>&1
  if test $? -eq 0; then
    echo "KILLED valgrind"
  fi
done
