#include <pyrame.h>


//free an event and all next event in the chained list
void free_event(struct event *e) {
  struct event *todel;
  struct event *iter=e;
  int i;
  while(iter!=NULL) {
    todel=iter;
    iter=iter->next;
    if (todel->time) {
      for (i=0;i<todel->time_size;i++) {
        if (todel->time[i])
          free(todel->time[i]);
      }
      free(todel->time);
    }
    if (todel->space) {
      for (i=0;i<todel->space_size;i++)
        if (todel->space[i])
          free(todel->space[i]);
      free(todel->space);
    }
    if (todel->data) {
      for (i=0;i<todel->data_size;i++)
        if (todel->data[i])
          free(todel->data[i]);
      free(todel->data);
    }
    free(todel);
  }
}

//create a new event
struct event *new_event(struct block *b) {
  struct event *e=malloc(sizeof(struct event));
  memset(e,0,sizeof(struct event));
  e->block=b;
  return e;
}

//create a new event
struct event *new_event_from_es(struct block *b) {
  struct event *e=malloc(sizeof(struct event));
  memset(e,0,sizeof(struct event));
  
  e->time=malloc(sizeof(char *)*b->es->nb_time);
  memset(e->time,0,sizeof(char *)*b->es->nb_time);
  e->time_size=b->es->nb_time;

  e->space=malloc(sizeof(char *)*b->es->nb_space);
  memset(e->space,0,sizeof(char *)*b->es->nb_space);
  e->space_size=b->es->nb_space;

  e->data=malloc(sizeof(char *)*b->es->nb_data);
  memset(e->data,0,sizeof(char *)*b->es->nb_data);
  e->data_size=b->es->nb_data;
  
  add_event(b,e);
  return e;
}


void print_event(struct event *e) {
  int i;
  if (e==NULL) {
    printf("null event\n");
    return;
  }
  if (e->used) {
    printf("[used event]");
  }
  if (e->time_size>0) {
    printf("time[%d]=",e->time_size);
    for(i=0;i<e->time_size;i++)
      printf("%s ",e->time[i]);
    printf("\n");
  } else {
    printf("no time data\n");
  }
  if (e->space_size>0) {
    printf("space[%d]=",e->space_size);
    for(i=0;i<e->space_size;i++)
      printf("%s ",e->space[i]);
    printf("\n");
  } else {
    printf("no space data\n");
  }
  if (e->data_size>0) {
    printf("data[%d]=",e->data_size);
    for(i=0;i<e->data_size;i++)
      printf("%s ",e->data[i]);
    printf("\n");
  } else {
    printf("no data\n");
  }
} 
