/*
 * Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
 * This file is part of Pyrame.
 *
 * Pyrame is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pyrame is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
 * */

#include <pyrame.h>


struct incr_string *new_is() {
  struct incr_string *res=malloc(sizeof(struct incr_string));
  res->str=(char *)malloc(1001);
  res->str[0]=0;
  res->size=0;
  res->alloc_size=1000;
  return res;
}

void allocmore_is(struct incr_string *res,int add_size) {
  int req_size=res->size+add_size;
  if (req_size<res->alloc_size) {
    return;
  }
  
  int new_size=((int)(req_size/1000)+1)*1000+1;
  res->str=realloc(res->str,new_size);
  res->alloc_size=new_size;
}

void suffix_is(struct incr_string *res,char * addstr) {
  int add_size=strlen(addstr);
  char * ptr;
  allocmore_is(res,add_size);
  ptr=res->str+res->size;
  sprintf(ptr,"%s",addstr);
  res->size+=add_size;
}

void fsuffix_is(struct incr_string *res,char *format,...) {
  char test[4096];
  int req_size;
  va_list pa;
  char * ptr;

  //compute the necessary size
  va_start(pa,format);
  req_size=vsnprintf(test,4096,format,pa);
  va_end(pa);
  
  //allocate necessary memory
  allocmore_is(res,req_size+10);

  //concatenate the two strings
  ptr=res->str+res->size;
  if (req_size<4096) {
    //test already contains the suffix
    strcpy(ptr,test);
  } else {
    va_start(pa,format);
    vsprintf(ptr,format,pa);
    va_end(pa);
  }
  res->size+=req_size;
}

void prefix_is(struct incr_string *res,char * addstr) {
  int add_size=strlen(addstr);
  char *cpy=strdup(res->str);
  allocmore_is(res,add_size);
  sprintf(res->str,"%s%s",addstr,cpy);
  res->size+=add_size;
  free(cpy);
}

void free_is(struct incr_string *res) {
  free(res->str);
  free(res);
}

char *reduce_is(struct incr_string *ires) {
  char *res=ires->str;
  free(ires);
  return res;
}
