/*
 * Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
 * This file is part of Pyrame.
 *
 * Pyrame is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pyrame is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
 * */

#include "pyrame.h"

void fill_stats(struct stats_ws *ws) {
  int i;
  for(i=0;i<6;i++) {
    set_stats(ws,"x",SOP_PLUS,1);
    if (i%2)
      set_stats(ws,"half",SOP_PLUS,1);
    set_stats(ws,"full",SOP_PLUS,1);
    usleep(1000000);
  }
  fflush(stdout);
}

int main() {
  int port=port=get_port("VARMOD_PORT");
  struct stats_ws *ws=init_stats("localhost",1000000);
  struct cmd_result *cres;
  add_acc(ws,"x",0);
  add_sw(ws,"swx","x",3);
  add_acc(ws,"half",0);
  add_acc(ws,"full",0);
  add_pc(ws,"pc","half","full");
  zero_stats(ws);
  fill_stats(ws);
  cres=sendcmd("localhost",port,"exit_module","end");
  free_cmd_result(cres);
  fill_stats(ws);
  system("cmdmod /opt/pyrame/cmd_varmod.xml -a 1 2 > varmod2.trace 2>&1 &");
  fill_stats(ws);
  sleep(1);
  dump_stats_to_log(ws,STDOUT_FILENO);
  deinit_stats(ws);
  sleep(1);
  return 0;
}
