#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all

echo 
echo 
echo "PATHS TESTS"
echo
autolauncher.py -n > server.trace 2>&1 &
wait_until_awake localhost $PATHS_PORT
wait_until_awake localhost $MOTION_PORT
wait_until_awake localhost $MAN_MOTION_PORT

exec_n_test ../cmd_motion/init.sh motiontest_x 'man_motion()'
exec_n_test ../cmd_motion/init.sh motiontest_y 'man_motion()'
exec_n_test ../cmd_motion/init.sh motiontest_z 'man_motion()'
exec_n_test ../cmd_motion/config.sh motiontest_x 100 0
exec_n_test ../cmd_motion/config.sh motiontest_y 100 0
exec_n_test ../cmd_motion/config.sh motiontest_z 100 0

exec_n_test ./init_space.sh testspace motiontest_x motiontest_y motiontest_z 0.5 0.5 0.5

exec_n_test ./init_volume.sh prismvol testspace prism prism "0,0;10,0;10,3;5,10;0,3;0,0" x 0 10
exec_n_test ./init_path.sh prismpath testspace prismvol 1 1 1 123 mm ppp
exec_n_test ./dump_path.sh prismpath test.txt
check_equal_files test.txt prism.ref
rm -f test.txt

exec_n_test ./init_volume.sh testvol testspace recpar recpar 0 10 0 10 0 10
exec_n_test ./init_volume.sh forbvol1 testspace sphere sphere 5 5 10 5
exec_n_test ./init_volume.sh forbvol2 testspace sphere sphere 5 5 0 5
#exec_n_test ./init_volume.sh forbvol1 testspace cylinder_z cylinder_z 5 5 2 0 10
exec_n_test ./add_limits.sh testspace forbvol1
exec_n_test ./add_limits.sh testspace forbvol2
exec_n_test ./init_path.sh testpath testspace testvol 1 1 1 123 mm ppp

exec_n_test ./dump_path.sh testpath test.txt
check_equal_files test.txt test.ref
rm -f test.txt

exec_n_test ./deinit_path.sh testpath
exec_n_test ./deinit_volume.sh testvol
exec_n_test ./deinit_volume.sh forbvol1
exec_n_test ./deinit_volume.sh forbvol2
exec_n_test ./deinit_space.sh testspace

clean_all
echo "all tests passed"
