#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

def init_recpar(min_x,max_x,min_y,max_y,min_z,max_z):
    volume={}
    volume["min_0"]=float(min_x)
    volume["min_1"]=float(min_y)
    volume["min_2"]=float(min_z)
    volume["max_0"]=float(max_x)
    volume["max_1"]=float(max_y)
    volume["max_2"]=float(max_z)
    return volume

def recpar(volume,errors,point):
    "Determine if *point* is inside the volume of the prism result of the extrusion of *face_to_extrude* from z_start to z_end. *face_to_extrude* is a semi-colon separated list of 2D coordinates, each of them comma-separated. *point* is a comma-separated list of the 3D coordinates of the point to probe."
    # parse arguments
    if (type(point) is not list and type(point) is not tuple) or len(point)!=3:
        raise Exception("recpar: point must be a list or tuple of three floats")
    # fast solving of points outside bounding box
    if point[0]>volume["max_0"] or point[0]<volume["min_0"] or \
       point[1]>volume["max_1"] or point[1]<volume["min_1"] or \
       point[2]>volume["max_2"] or point[2]<volume["min_2"]:
        return False
    return True
