#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

import math

def init_sphere(origin_x,origin_y,origin_z,radius):
    volume={}
    volume["origin_x"]=float(origin_x)
    volume["origin_y"]=float(origin_y)
    volume["origin_z"]=float(origin_z)
    volume["radius"]=float(radius)
    volume["min_0"]=float(origin_x)-float(radius)
    volume["min_1"]=float(origin_y)-float(radius)
    volume["min_2"]=float(origin_z)-float(radius)
    volume["max_0"]=float(origin_x)+float(radius)
    volume["max_1"]=float(origin_y)+float(radius)
    volume["max_2"]=float(origin_z)+float(radius)
    return volume

def sphere(volume,errors,point):
    # parse arguments
    if (type(point) is not list and type(point) is not tuple) or len(point)!=3:
        raise Exception("sphere: point must be a list or tuple of three floats")

    dist=math.sqrt((volume["origin_x"]-point[0])**2
              +(volume["origin_y"]-point[1])**2
              +(volume["origin_z"]-point[2])**2)

    if dist>volume["radius"]:
        return False

    return True
