# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

import os,string,random
import pools
mount_pool=pools.pool("mount")

def init():
    os.system("for i in /opt/pyrame/mnt/*; do umount $i; rmdir $i; done")
    
def id_generator(size=6, chars=string.ascii_uppercase + string.digits):
    return ''.join(random.choice(chars) for _ in range(size))

def mount_mountd(uri):
    try:
        m=mount_pool.get(uri)
        return 1,m["path"]
    except:
        pass
    euri=uri.split("://")
    if len(euri)!=2:
        return 0,"invalid uri"
    proto=euri[0]
    share=euri[1]
    if proto=="file":
        tmpname=share
    if proto=="nfs":
        tmpname="/opt/pyrame/mnt/"+id_generator(16)
        rsmk=os.system("mkdir -p %s"%(tmpname))
        if rsmk!=0:
            return 0,"unable to create folder"
        share=share.replace("/",":/",1)
        rsmo=os.system("mount -t %s %s %s"%(proto,share,tmpname))
        if rsmo!=0:
            return 0,"unable to mount uri"
    mount_pool.new(uri,{"path":tmpname})
    return 1,tmpname
    
def umount_mountd(uri):
    try:
        m=mount_pool.get(uri)
    except:
        return 0,str(e)
    rsmu=os.system("umount %s"%(m["path"]))
    if rsmu!=0:
       return 0,"unable to umount path" 
    rsrm=os.system("rm -rf %s"%(m["path"]))
    if rsrm!=0:
       return 0,"unable to remove folder" 
    mount_pool.remove(uri)
    return 1,"ok"

def available_mountd(uri):
    try:
        m=mount_pool.get(uri)
    except:
        return 0,str(e)
    return 1,m["path"]
