#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

def get_type(x):
    if type(x)==str:
        return "0"
    if type(x)==int:
        return "1"
    if type(x)==float:
        return "2"
    return "-1"

class penv(dict):

    def __init__(self):
        try:
            self.submod=__import__("__main__").submod
        except:
            pass

    def __del__(self):
        pass

    def __setitem__(self,key,value):
        vtype=get_type(value)
        if vtype==-1:
            raise Exception("unsupported type: %s"%(type(value)))
        retcode,res=self.submod.callwrap("setvar","system",key,str(value),vtype)
        if retcode==0:
            raise Exception("unable to setvar: %s"%(res))
        return

    def __getitem__(self,key):
        retcode,v=self.submod.callwrap("getvar","system",key)
        if retcode==0:
            raise Exception("unable to getvar %s: %s"%(key,v))
        retcode,vtype=self.submod.callwrap("gettype","system",key)
        #print("reading %s : res=%s type=%s value=%s"%(key,res,vtype,v))
        if vtype=="0":
            return v
        if vtype=="1":
            return int(v)
        if vtype=="2":
            return float(v)
        raise Exception("unknown type %s"%(vtype))

    def __delitem__(self,key):
        #print("delitem")
        retcode,res=self.submod.callwrap("delvar","system",id)
        if retcode==0:
            raise Exception("unable to delvar: %s"%(res))
        return 

    def clear(self):
        pass

    def setdefault(self,key,value=None):
        pass

