#!/bin/bash
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2015 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh

clean_all
sleep 1s
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_isegshq.xml > isegshq.trace 2>&1 &
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_serial.xml > serial.trace 2>&1 &
wait_until_awake localhost $ISEGSHQ_PORT
wait_until_awake localhost $SERIAL_PORT
set -x
exec_n_test ./init.sh "isegshq(bus=serial(),device=/dev/ttyS0)"
id=`cat ent.trace | awk -F= '{ print $3 }'`

exec_n_test ./config.sh $id "debug" '#'

exec_n_test ./get_voltage.sh $id 1
v0=`cat ent.trace | awk -F= '{ print $3 }'`
exec_n_test ./set_voltage.sh $id 2.9 1

exec_n_test ./get_voltage.sh $id 1
v=`cat ent.trace | awk -F= '{ print $3 }'`
#check_equal_values $v "2.9"
exec_n_test ./set_voltage.sh $id $v0 1

exec_n_test ./inval.sh $id
exec_n_test ./deinit.sh $id

clean_all
echo "all tests passed"
