#!/bin/bash
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

IP=10.220.0.72
GPIB_ADDR=22

clean_all
sleep 1s
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_ps.xml > ps.trace 2>&1 &
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_ki_6487.xml > ki_6487.trace 2>&1 &
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_multimeter.xml > multimeter.trace 2>&1 &
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_mm_ki_6487.xml > mm_ki_6487.trace 2>&1 &
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_gpib.xml > gpib.trace 2>&1 &
stdbuf -oL -eL cmdmod /opt/pyrame/cmd_tcp.xml > tcp.trace 2>&1 &
wait_until_awake localhost $PS_PORT
wait_until_awake localhost $KI_6487_PORT
wait_until_awake localhost $MULTIMETER_PORT
wait_until_awake localhost $MM_KI_6487_PORT
wait_until_awake localhost $GPIB_PORT
wait_until_awake localhost $TCP_PORT

./unit_test_eth.py "ki_6487(bus=gpib(bus=tcp(host=$IP),dst_addr=$GPIB_ADDR))" "mm_ki_6487(bus=gpib(bus=tcp(host=$IP),dst_addr=$GPIB_ADDR))" > test.raw
gnuplot -e "filename='test.raw';slope=1/10e6;error=0.03" unit_test.gnuplot > gnuplot.trace 2>&1 
check_empty_file gnuplot.trace

#for firmware A03
#exec_n_test ./unit_test.py "ki_6487(bus=gpib(bus=tcp(host=$IP),dst_addr=$GPIB_ADDR))" "mm_ki_6487(bus=gpib(bus=tcp(host=$IP),dst_addr=$GPIB_ADDR))" > test.raw
#check_equal_files ref-A03-I-V-10MOhm-350V.txt test.raw

clean_all
echo "all tests passed"
