#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

g_voltage="0"
fcurrent=-1
alims={}

# COMMANDS #######################################################

def init_man_ps(man_ps_id,conf_string):
    """Initialize man_ps power supply."""
    alims[man_ps_id]=["0","0"]
    return 1,"0"

def deinit_man_ps(man_ps_id):
    "Deinitialize an man_ps"
    del alims[man_ps_id]
    return 1,"ok"

def config_man_ps(man_ps_id):
    "Configure an man_ps"
    return 1,"ok"

def inval_man_ps(man_ps_id):
    "Invalidate an man_ps"
    return 1,"ok"

def reset_man_ps(man_ps_id):
    "Send RST signal to PS"
    alims[man_ps_id]=["0","0"]
    return 1,"ok"

def set_voltage_man_ps(man_ps_id,voltage,slew_rate):
    alims[man_ps_id][0]=voltage
    return 1,"ok"

def set_current_man_ps(man_ps_id,current):
    "Set current in Ampers."
    alims[man_ps_id][1]=current
    return 1,"ok"

def set_voltage_limit_man_ps(man_ps_id,voltage_limit):
    "Set voltage limit in Volts. Over Voltage Protection is also set."
    return 1,"ok"

def set_current_limit_man_ps(man_ps_id,current_limit):
    "Set current limit in Ampers."
    return 1,"ok"

def get_voltage_man_ps(man_ps_id):
    "Get voltage in Volts."
    return 1,alims[man_ps_id][0]

def get_current_man_ps(man_ps_id):
    "Get current in Ampers."
    return 1,alims[man_ps_id][1]

def power_on_man_ps(man_ps_id):
    "Turn on ps."
    return 1,"ok"

def power_off_man_ps(man_ps_id):
    "Turn off ps."
    return 1,"ok"

def set_rise_delay_man_ps(man_ps_id,rise_delay):
    "Set power-on (rise) delay in seconds."
    return 1,"ok"

def free_command_man_ps(man_ps_id,command):
    "Send a raw command to the PS"
    return 1,"ok"

def get_error_queue_man_ps(man_ps_id):
    "Read error queue until the end (code 0)"
    return 1,"ok"
