#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all

echo 
echo 
echo "MAN_PS TESTS"
echo
cmdmod /opt/pyrame/cmd_man_ps.xml -d > server.trace 2>&1 &
wait_until_awake localhost $MAN_PS_PORT
exec_n_test ./init.sh manps "man_ps()"

exec_n_test ./config.sh manps
exec_n_test ./get_voltage.sh manps
v0=`cat ent.trace | awk -F= '{ print $3 }'`
exec_n_test ./set_voltage.sh manps 2.9 1

exec_n_test ./get_voltage.sh manps
v=`cat ent.trace | awk -F= '{ print $3 }'`
#check_equal_values $v "2.9"
exec_n_test ./set_voltage.sh manps $v0 1

exec_n_test ./inval.sh manps
exec_n_test ./deinit.sh manps

clean_all
echo "all tests passed"
