#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

import time,datetime

progress=0

def unit_test_acq_init():
    declare_param("xml_config","calxml configuration file","")
    declare_param("acq_time","duration of acquisition","0")

def unit_test_acq_run(xml_config,acq_time):
    global progress
    progress=0

    print("unit_test_acq: resetting to deinitialized")
    try:
        transition("test_smtest","deinit","undef")
    except:
        pass

    print("unit_test_acq: loading config file")
    load_config_file(xml_config)

    progress=10
    print("unit_test_acq: initialize")
    transition("test_smtest","init","deinit")

    progress=20
    print("unit_test_acq: configure")
    transition("test_smtest","config","inval")

    progress=30
    run_name="unit_test_acq/%s"%(datetime.datetime.now().strftime("%Y%m%d_%H%M%S"))
    print("unit_test_acq: creating run %s"%(run_name))
    run=new_run_rcs("storage",run_name)

    progress=40
    print("unit_test_acq: start acq in run %s"%(run))
    acq=new_acq_rcs("storage","single_acq",run)
    transition("test_smtest","start_acq","undef","{'complete_prefix':'%s'}"%(acq["path"]))
    
    div=3
    try:
        for i in range(div):
            print("sleeping for %.1fs..."%(float(acq_time)/div))
            int_sleep(float(acq_time)/div)
            progress=40+i*30/div
    finally:
        print("unit_test_acq: stop acq")
        transition("test_smtest","stop_acq","undef")

    progress=80
    print("unit_test_acq: invalidate")
    transition("test_smtest","inval","undef")

    progress=90
    print("unit_test_acq: deinitialize")
    transition("test_smtest","deinit","undef")

    progress=100

def unit_test_acq_get_progress():
    return progress

execfile("/opt/pyrame/common_rcs.py")

