#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh

exec_n_test ./load_script.sh "`pwd`/scripts/unit_test_acq.py"
exec_n_test ./set_script_param.sh xml_config "`pwd`/scripts/test_rc.xml"
exec_n_test ./set_script_param.sh acq_time 10
exec_n_test ./start_script.sh
STOPPED=false
i=0
while ! $STOPPED && test $i -lt 12; do
  exec_n_test ./get_script_progress.sh
  if test "$RETSTR" = "end" || test "$RETSTR" = "stop"; then
    STOPPED=true
  elif $STOPPED; then
    echo "stopped and not receiving end or stop"
    exit 1
  elif test "$RETSTR" -lt 0 || test "$RETSTR" -gt 100; then
    echo "invalid progress"
    exit 1
  fi
  exec_n_test ./get_last_script_error.sh
  # check we don't have errors
  if [ "$RETSTR" != "" ]; then
    echo $RETSTR
    exit 1
  fi
  sleep 1s
  i=`expr $i + 1`
done
exec_n_test ./stop_script.sh
