#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh

exec_n_test ./load_script.sh "`pwd`/scripts/unit_test_acq.py"
exec_n_test ./start_script.sh
sleep 0.5s
exec_n_test ./get_last_script_error.sh
# we didn't set params. we expect error
# check we DO have an error (not empty return)
if [ "$RETSTR" = "" ]; then
  echo "bad last error"
  exit 1
fi
# sleep 1s so that next run name is not the same (%H%M%S)
sleep 1s
exec_n_test ./set_script_param.sh xml_config "`pwd`/scripts/test_rc.xml"
exec_n_test ./set_script_param.sh acq_time 5
exec_n_test ./start_script.sh
echo "sleeping for 10s"
sleep 10s
exec_n_test ./get_last_script_error.sh
# check we don't have errors
if [ "$RETSTR" != "" ]; then
  echo $RETSTR
  exit 1
fi
