#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh

exec_n_test ./load_script.sh "`pwd`/scripts/unit_test_acq.py"
for i in 0 0.1 0.2 0.5 `seq 2 5 12`; do
  exec_n_test ./set_script_param.sh xml_config "`pwd`/scripts/test_rc.xml"
  exec_n_test ./set_script_param.sh acq_time 10
  exec_n_test ./start_script.sh
  echo "waiting ${i}s before stopping script..."
  sleep ${i}s
  exec_n_test ./get_last_script_error.sh
  # check we don't have errors
  if [ "$RETSTR" != "" ]; then
    echo bad last error: $RETSTR
    exit 1
  fi
  exec_n_test ./stop_script.sh
  # sleep 1s so that next run name is not the same (%H%M%S)
  sleep 1s
done
