#!/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

import sys
import common_roc

if len(sys.argv)<2:
    print("usage: %s binary_string [msb_padding:True|False]"%(sys.argv[0]))
    print("       msb_padding is True by default")
    sys.exit(1)

if len(sys.argv)>2:
    if sys.argv[2].lower()=="true":
        msb_padding=True
        padding="MSB"
    elif sys.argv[2].lower()=="false":
        msb_padding=False
        padding="LSB"
    else:
        print("invalid value for msb_padding. Must be either True or False")
        sys.exit(1)

hex_str = common_roc.bin2hexa(sys.argv[1],msb_padding)

print("hexadecimal conversion with %s padding: %s"%(padding,hex_str))
