#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

import sys
import common_roc

test_suite=["10001111","00001111","100001111","000001111","10001100","010010"]
msb_result=["8f",      "0f",      "10f",      "00f",      "8c",      "12"]
lsb_result=["8f",      "0f",      "878",      "078",      "8c",      "48"]

#msb_padding=True
for i in range(len(test_suite)):
    print("Checking bin2hex with msb_padding on %s ..."%(test_suite[i])),
    res=common_roc.bin2hexa(test_suite[i])
    if res==msb_result[i]:
        print("success")
    else:
        print("failure. Got %s instead of %s"%(res,msb_result[i]))
        sys.exit(1)
    print("Checking bin2hex with lsb_padding on %s ..."%(test_suite[i])),
    res=common_roc.bin2hexa(test_suite[i],False)
    if res==lsb_result[i]:
        print("success")
    else:
        print("failure. Got %s instead of %s"%(res,lsb_result[i]))
        sys.exit(1)

print("all tests passed")
