#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "EASIROC TESTS"
echo
cmdmod /opt/pyrame/cmd_cmod.xml > cmod.trace 2>&1 &
cmdmod /opt/pyrame/cmd_easiroc.xml > easiroc.trace 2>&1 &
wait_until_awake localhost $CMOD_PORT
wait_until_awake localhost $EASIROC_PORT
exec_n_test ./load_config_file.sh `pwd`/test.xml
exec_n_test ./init.sh easiroc_1
exec_n_test ./config.sh easiroc_1 `pwd`/easiroc_default.txt undef undef undef undef undef undef undef undef undef undef undef undef

checkretstr 1 ./get_param.sh easiroc_1 d_output
checkretstr 0 ./get_param.sh easiroc_1 gtrigger
checkretstr 175ns ./get_param.sh easiroc_1 hg_tau
checkretstr 175ns ./get_param.sh easiroc_1 lg_tau
checkretstr 3.5pF ./get_param.sh easiroc_1 hg_comp_capa
checkretstr 0.0pF ./get_param.sh easiroc_1 hg_fb_capa
checkretstr 3.5pF ./get_param.sh easiroc_1 lg_comp_capa
checkretstr 0.5pF ./get_param.sh easiroc_1 lg_fb_capa
checkretstr weak ./get_param.sh easiroc_1 lg_preamp_bias

exec_n_test ./set_d_output.sh easiroc_1 OFF
exec_n_test ./set_gtrigger.sh easiroc_1 328
exec_n_test ./set_hg_tau.sh easiroc_1 125ns
exec_n_test ./set_lg_tau.sh easiroc_1 150ns
exec_n_test ./set_hg_comp_capa.sh easiroc_1 5.5pF
exec_n_test ./set_hg_fb_capa.sh easiroc_1 0.2pF
exec_n_test ./set_lg_comp_capa.sh easiroc_1 4.5pF
exec_n_test ./set_lg_fb_capa.sh easiroc_1 0.3pF
exec_n_test ./set_lg_preamp_bias.sh easiroc_1 high
exec_n_test ./disable_input_dac.sh easiroc_1 all
exec_n_test ./enable_input_dac.sh easiroc_1 2,3,5,7,11,13,17,19,23,29,31

checkretstr 0 ./get_param.sh easiroc_1 d_output
checkretstr 328 ./get_param.sh easiroc_1 gtrigger
checkretstr 125ns ./get_param.sh easiroc_1 hg_tau
checkretstr 150ns ./get_param.sh easiroc_1 lg_tau
checkretstr 5.5pF ./get_param.sh easiroc_1 hg_comp_capa
checkretstr 0.2pF ./get_param.sh easiroc_1 hg_fb_capa
checkretstr 4.5pF ./get_param.sh easiroc_1 lg_comp_capa
checkretstr 0.3pF ./get_param.sh easiroc_1 lg_fb_capa
checkretstr high ./get_param.sh easiroc_1 lg_preamp_bias
checkretstr 2,3,5,7,11,13,17,19,23,29,31 ./get_param.sh easiroc_1 enable_input_dac_chans
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30 ./get_param.sh easiroc_1 disable_input_dac_chans
checkretstr `cat ref_bs.txt` ./get_param.sh easiroc_1 bitstream

#reconfigure
exec_n_test ./config.sh easiroc_1 undef `cat ref_bs.txt` 1 329 175ns 100ns 5pF 0.4pF 3pF 0.6pF weak 0-16 17-31

checkretstr 1 ./get_param.sh easiroc_1 d_output
checkretstr 329 ./get_param.sh easiroc_1 gtrigger
checkretstr 175ns ./get_param.sh easiroc_1 hg_tau
checkretstr 100ns ./get_param.sh easiroc_1 lg_tau
checkretstr 5.0pF ./get_param.sh easiroc_1 hg_comp_capa
checkretstr 0.4pF ./get_param.sh easiroc_1 hg_fb_capa
checkretstr 3.0pF ./get_param.sh easiroc_1 lg_comp_capa
checkretstr 0.6pF ./get_param.sh easiroc_1 lg_fb_capa
checkretstr weak ./get_param.sh easiroc_1 lg_preamp_bias
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16 ./get_param.sh easiroc_1 enable_input_dac_chans
checkretstr 17,18,19,20,21,22,23,24,25,26,27,28,29,30,31 ./get_param.sh easiroc_1 disable_input_dac_chans

exec_n_test ./explain.sh easiroc_1

clean_all
echo "all tests passed"
