#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "MAROC3 TESTS"
echo
cmdmod /opt/pyrame/cmd_cmod.xml -d > cmod.trace 2>&1 &
cmdmod /opt/pyrame/cmd_maroc3.xml -d > maroc3.trace 2>&1 &
wait_until_awake localhost $CMOD_PORT
wait_until_awake localhost $MAROC3_PORT
exec_n_test ./load_config_file.sh `pwd`/test.xml
exec_n_test ./init.sh maroc3_1
exec_n_test ./config.sh maroc3_1 `pwd`/maroc3_default.txt undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef

checkretstr 1 ./get_param.sh maroc3_1 pp_bandgap
checkretstr 1 ./get_param.sh maroc3_1 pp_dacs
checkretstr 1 ./get_param.sh maroc3_1 small_dac
checkretstr 450 ./get_param.sh maroc3_1 dac0
checkretstr 0 ./get_param.sh maroc3_1 dac1
checkretstr 0 ./get_param.sh maroc3_1 data_output_wlk
checkretstr 0 ./get_param.sh maroc3_1 inv_start_counter_wlk
checkretstr 0 ./get_param.sh maroc3_1 ramp_8bit_wlk
checkretstr 0 ./get_param.sh maroc3_1 ramp_10bit_wlk
checkretstr 0b000110000101100000110111110000110 ./get_param.sh maroc3_1 from_156_to_188
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh maroc3_1 allow_trig_or1_chans
checkretstr "" ./get_param.sh maroc3_1 disallow_trig_or1_chans
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh maroc3_1 allow_trig_or2_chans
checkretstr "" ./get_param.sh maroc3_1 disallow_trig_or2_chans
checkretstr "" ./get_param.sh maroc3_1 enable_sum_chans
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh maroc3_1 disable_sum_chans
checkretstr "" ./get_param.sh maroc3_1 enable_ctest_chans
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh maroc3_1 disable_ctest_chans

exec_n_test ./set_pp_bandgap.sh maroc3_1 0
exec_n_test ./set_pp_dacs.sh maroc3_1 0
exec_n_test ./set_small_dac.sh maroc3_1 0
exec_n_test ./set_dac0.sh maroc3_1 233
exec_n_test ./set_dac1.sh maroc3_1 123
exec_n_test ./set_data_output_wlk.sh maroc3_1 1
exec_n_test ./set_inv_start_counter_wlk.sh maroc3_1 1
exec_n_test ./set_ramp_8bit_wlk.sh maroc3_1 1
exec_n_test ./set_ramp_10bit_wlk.sh maroc3_1 1
exec_n_test ./set_from_156_to_188.sh maroc3_1 0b111001111010011111001000101110001
exec_n_test ./allow_trig_or1.sh maroc3_1 all
exec_n_test ./disallow_trig_or1.sh maroc3_1 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61
exec_n_test ./disallow_trig_or2.sh maroc3_1 all
exec_n_test ./allow_trig_or2.sh maroc3_1 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61
exec_n_test ./enable_sum.sh maroc3_1 0-31
exec_n_test ./disable_sum.sh maroc3_1 32-63
exec_n_test ./enable_ctest.sh maroc3_1 0-20,50-63
exec_n_test ./disable_ctest.sh maroc3_1 21-49

checkretstr 0 ./get_param.sh maroc3_1 pp_bandgap
checkretstr 0 ./get_param.sh maroc3_1 pp_dacs
checkretstr 0 ./get_param.sh maroc3_1 small_dac
checkretstr 233 ./get_param.sh maroc3_1 dac0
checkretstr 123 ./get_param.sh maroc3_1 dac1
checkretstr 1 ./get_param.sh maroc3_1 data_output_wlk
checkretstr 1 ./get_param.sh maroc3_1 inv_start_counter_wlk
checkretstr 1 ./get_param.sh maroc3_1 ramp_8bit_wlk
checkretstr 1 ./get_param.sh maroc3_1 ramp_10bit_wlk
checkretstr 0b111001111010011111001000101110001 ./get_param.sh maroc3_1 from_156_to_188
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32,33,34,35,36,38,39,40,42,44,45,46,48,49,50,51,52,54,55,56,57,58,60,62,63 ./get_param.sh maroc3_1 allow_trig_or1_chans
checkretstr 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61 ./get_param.sh maroc3_1 disallow_trig_or1_chans
checkretstr 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61 ./get_param.sh maroc3_1 allow_trig_or2_chans
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32,33,34,35,36,38,39,40,42,44,45,46,48,49,50,51,52,54,55,56,57,58,60,62,63 ./get_param.sh maroc3_1 disallow_trig_or2_chans
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31 ./get_param.sh maroc3_1 enable_sum_chans
checkretstr 32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh maroc3_1 disable_sum_chans
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh maroc3_1 enable_ctest_chans
checkretstr 21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49 ./get_param.sh maroc3_1 disable_ctest_chans
checkretstr `cat ref_bs.txt` ./get_param.sh maroc3_1 bitstream

#reconfigure
exec_n_test ./config.sh maroc3_1 undef `cat ref_bs.txt` 1 1 1 450 0 0 0 0 0 0b000110000101100000110111110000110 all undef all undef undef all undef all

checkretstr 1 ./get_param.sh maroc3_1 pp_bandgap
checkretstr 1 ./get_param.sh maroc3_1 pp_dacs
checkretstr 1 ./get_param.sh maroc3_1 small_dac
checkretstr 450 ./get_param.sh maroc3_1 dac0
checkretstr 0 ./get_param.sh maroc3_1 dac1
checkretstr 0 ./get_param.sh maroc3_1 data_output_wlk
checkretstr 0 ./get_param.sh maroc3_1 inv_start_counter_wlk
checkretstr 0 ./get_param.sh maroc3_1 ramp_8bit_wlk
checkretstr 0 ./get_param.sh maroc3_1 ramp_10bit_wlk
checkretstr 0b000110000101100000110111110000110 ./get_param.sh maroc3_1 from_156_to_188
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh maroc3_1 allow_trig_or1_chans
checkretstr "" ./get_param.sh maroc3_1 disallow_trig_or1_chans
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh maroc3_1 allow_trig_or2_chans
checkretstr "" ./get_param.sh maroc3_1 disallow_trig_or2_chans
checkretstr "" ./get_param.sh maroc3_1 enable_sum_chans
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh maroc3_1 disable_sum_chans
checkretstr "" ./get_param.sh maroc3_1 enable_ctest_chans
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh maroc3_1 disable_ctest_chans
checkretstr `cat maroc3_default.txt` ./get_param.sh maroc3_1 bitstream

clean_all
echo "all tests passed"
