#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "SKIROC TESTS"
echo
cmdmod /opt/pyrame/cmd_cmod.xml -d > cmod.trace 2>&1 &
cmdmod /opt/pyrame/cmd_skiroc.xml -d > skiroc.trace 2>&1 &
wait_until_awake localhost $CMOD_PORT
wait_until_awake localhost $SKIROC_PORT
exec_n_test ./load_config_file.sh `pwd`/test.xml
exec_n_test ./init.sh skiroc_1
exec_n_test ./set_chipid_param.sh skiroc_1 14
exec_n_test ./config.sh skiroc_1 `pwd`/skiroc_default.txt undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef

checkretstr 0xfe4240305f024a821c800000000000000044444444444444444444444444444444444444444444444444444444444444442ad3aa0000000000000000000000000000000000000000000000019d ./get_param.sh skiroc_1 bitstream
checkretstr ext ./get_param.sh skiroc_1 trig_mode
checkretstr 1 ./get_param.sh skiroc_1 end_ro
checkretstr 1 ./get_param.sh skiroc_1 start_ro
checkretstr 1.2pF ./get_param.sh skiroc_1 fbcap
checkretstr 6pF ./get_param.sh skiroc_1 cpcap
checkretstr 112 ./get_param.sh skiroc_1 delay
checkretstr 288 ./get_param.sh skiroc_1 gtrigger
checkretstr 1 ./get_param.sh skiroc_1 adc_discri
checkretstr 1 ./get_param.sh skiroc_1 auto_gain
checkretstr 500 ./get_param.sh skiroc_1 dac1_gain
checkretstr high ./get_param.sh skiroc_1 forced_gain
checkretstr 120ns ./get_param.sh skiroc_1 fs_tau
checkretstr 0 ./get_param.sh skiroc_1 gain_select
checkretstr 1 ./get_param.sh skiroc_1 pp_10bit_dual_dac
checkretstr 1 ./get_param.sh skiroc_1 pp_adc_discri
checkretstr 1 ./get_param.sh skiroc_1 pp_adc_ramp
checkretstr 1 ./get_param.sh skiroc_1 pp_bandgap
checkretstr 1 ./get_param.sh skiroc_1 pp_dac4
checkretstr 1 ./get_param.sh skiroc_1 pp_fs
checkretstr 1 ./get_param.sh skiroc_1 pp_gain_select
checkretstr 1 ./get_param.sh skiroc_1 pp_lvds_recv
checkretstr 1 ./get_param.sh skiroc_1 pp_preamp
checkretstr 1 ./get_param.sh skiroc_1 pp_sca
checkretstr 1 ./get_param.sh skiroc_1 pp_ss_g10
checkretstr 1 ./get_param.sh skiroc_1 pp_ss_g1
checkretstr 1 ./get_param.sh skiroc_1 pp_trig_delay
checkretstr 1 ./get_param.sh skiroc_1 pp_trig_discri
checkretstr 1 ./get_param.sh skiroc_1 trig_delay
exec_n_test ./set_trig_mode.sh skiroc_1 int
exec_n_test ./set_gtrigger.sh skiroc_1 328
exec_n_test ./set_fbcap.sh skiroc_1 3.2pF
exec_n_test ./set_cpcap.sh skiroc_1 3pF
exec_n_test ./set_start_ro.sh skiroc_1 2
exec_n_test ./set_end_ro.sh skiroc_1 2
exec_n_test ./disable_preamp.sh skiroc_1 0-63
exec_n_test ./enable_preamp.sh skiroc_1 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61
exec_n_test ./enable_calib.sh skiroc_1 0-63
exec_n_test ./disable_calib.sh skiroc_1 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61
exec_n_test ./enable_high_leak.sh skiroc_1 0-63
exec_n_test ./disable_high_leak.sh skiroc_1 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61
exec_n_test ./disallow_trig.sh skiroc_1 0-63
exec_n_test ./allow_trig.sh skiroc_1 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61
exec_n_test ./set_adc_discri.sh skiroc_1 0
exec_n_test ./set_auto_gain.sh skiroc_1 1
exec_n_test ./set_dac1_gain.sh skiroc_1 682
exec_n_test ./set_forced_gain.sh skiroc_1 low
exec_n_test_fail ./set_fs_tau.sh skiroc_1 30
exec_n_test_fail ./set_fs_tau.sh skiroc_1 3ns
exec_n_test ./set_fs_tau.sh skiroc_1 30ns
exec_n_test ./set_gain_select.sh skiroc_1 1
exec_n_test ./set_pp_10bit_dual_dac.sh skiroc_1 0
exec_n_test ./set_pp_adc_discri.sh skiroc_1 1
exec_n_test ./set_pp_adc_ramp.sh skiroc_1 0
exec_n_test ./set_pp_bandgap.sh skiroc_1 1
exec_n_test ./set_pp_dac4.sh skiroc_1 0
exec_n_test ./set_pp_fs.sh skiroc_1 1
exec_n_test ./set_pp_gain_select.sh skiroc_1 0
exec_n_test ./set_pp_lvds_recv.sh skiroc_1 1
exec_n_test ./set_pp_preamp.sh skiroc_1 0
exec_n_test ./set_pp_sca.sh skiroc_1 1
exec_n_test ./set_pp_ss_g10.sh skiroc_1 0
exec_n_test ./set_pp_ss_g1.sh skiroc_1 1
exec_n_test ./set_pp_trig_delay.sh skiroc_1 0
exec_n_test ./set_pp_trig_discri.sh skiroc_1 1
exec_n_test ./set_trig_delay.sh skiroc_1 0

checkretstr int ./get_param.sh skiroc_1 trig_mode
checkretstr 328 ./get_param.sh skiroc_1 gtrigger
checkretstr 3.2pF ./get_param.sh skiroc_1 fbcap
checkretstr 3pF ./get_param.sh skiroc_1 cpcap
checkretstr 2 ./get_param.sh skiroc_1 start_ro
checkretstr 2 ./get_param.sh skiroc_1 end_ro
checkretstr 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61 ./get_param.sh skiroc_1 enable_preamp_chans
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32,33,34,35,36,38,39,40,42,44,45,46,48,49,50,51,52,54,55,56,57,58,60,62,63 ./get_param.sh skiroc_1 disable_preamp_chans
checkretstr 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61 ./get_param.sh skiroc_1 disable_calib_chans
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32,33,34,35,36,38,39,40,42,44,45,46,48,49,50,51,52,54,55,56,57,58,60,62,63 ./get_param.sh skiroc_1 enable_calib_chans
checkretstr 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61 ./get_param.sh skiroc_1 disable_high_leak_chans
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32,33,34,35,36,38,39,40,42,44,45,46,48,49,50,51,52,54,55,56,57,58,60,62,63 ./get_param.sh skiroc_1 enable_high_leak_chans
checkretstr 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61 ./get_param.sh skiroc_1 allow_trig_chans
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32,33,34,35,36,38,39,40,42,44,45,46,48,49,50,51,52,54,55,56,57,58,60,62,63 ./get_param.sh skiroc_1 disallow_trig_chans
checkretstr 0 ./get_param.sh skiroc_1 adc_discri
checkretstr 1 ./get_param.sh skiroc_1 auto_gain
checkretstr 682 ./get_param.sh skiroc_1 dac1_gain
checkretstr low ./get_param.sh skiroc_1 forced_gain
checkretstr 30ns ./get_param.sh skiroc_1 fs_tau
checkretstr 1 ./get_param.sh skiroc_1 gain_select
checkretstr 0 ./get_param.sh skiroc_1 pp_10bit_dual_dac
checkretstr 1 ./get_param.sh skiroc_1 pp_adc_discri
checkretstr 0 ./get_param.sh skiroc_1 pp_adc_ramp
checkretstr 1 ./get_param.sh skiroc_1 pp_bandgap
checkretstr 0 ./get_param.sh skiroc_1 pp_dac4
checkretstr 1 ./get_param.sh skiroc_1 pp_fs
checkretstr 0 ./get_param.sh skiroc_1 pp_gain_select
checkretstr 1 ./get_param.sh skiroc_1 pp_lvds_recv
checkretstr 0 ./get_param.sh skiroc_1 pp_preamp
checkretstr 1 ./get_param.sh skiroc_1 pp_sca
checkretstr 0 ./get_param.sh skiroc_1 pp_ss_g10
checkretstr 1 ./get_param.sh skiroc_1 pp_ss_g1
checkretstr 0 ./get_param.sh skiroc_1 pp_trig_delay
checkretstr 1 ./get_param.sh skiroc_1 pp_trig_discri
checkretstr 0 ./get_param.sh skiroc_1 trig_delay
checkretstr `cat ref_bs.txt` ./get_param.sh skiroc_1 bitstream

exec_n_test ./set_adc_discri.sh skiroc_1 1
exec_n_test ./set_auto_gain.sh skiroc_1 0
exec_n_test ./set_dac1_gain.sh skiroc_1 1023
exec_n_test ./set_forced_gain.sh skiroc_1 high
exec_n_test ./set_fs_tau.sh skiroc_1 60ns
exec_n_test ./set_gain_select.sh skiroc_1 0
exec_n_test ./set_pp_10bit_dual_dac.sh skiroc_1 1
exec_n_test ./set_pp_adc_discri.sh skiroc_1 0
exec_n_test ./set_pp_adc_ramp.sh skiroc_1 1
exec_n_test ./set_pp_bandgap.sh skiroc_1 0
exec_n_test ./set_pp_dac4.sh skiroc_1 1
exec_n_test ./set_pp_fs.sh skiroc_1 0
exec_n_test ./set_pp_gain_select.sh skiroc_1 1
exec_n_test ./set_pp_lvds_recv.sh skiroc_1 0
exec_n_test ./set_pp_preamp.sh skiroc_1 1
exec_n_test ./set_pp_sca.sh skiroc_1 0
exec_n_test ./set_pp_ss_g10.sh skiroc_1 1
exec_n_test ./set_pp_ss_g1.sh skiroc_1 0
exec_n_test ./set_pp_trig_delay.sh skiroc_1 1
exec_n_test ./set_pp_trig_discri.sh skiroc_1 0
exec_n_test ./set_trig_delay.sh skiroc_1 1

checkretstr `cat ref_bs2.txt` ./get_param.sh skiroc_1 bitstream
exec_n_test ./explain.sh skiroc_1
#reconfigure
exec_n_test ./config.sh skiroc_1 undef `cat ref_bs.txt` 329 57 0.8pF 1pF 1 1 0,2-3,14-63 1,4-13 0-5,20-63 6-19 0-31 32-63 0,30-33,31-63 1-29 ext 1 0 1 0 60ns 0 1 0 1 1 0 high 1 0 0 1 0 1 1023 1 0

checkretstr 329 ./get_param.sh skiroc_1 gtrigger
checkretstr 57 ./get_param.sh skiroc_1 delay
checkretstr 0.8pF ./get_param.sh skiroc_1 fbcap
checkretstr 1pF ./get_param.sh skiroc_1 cpcap
checkretstr 1 ./get_param.sh skiroc_1 end_ro
checkretstr 1 ./get_param.sh skiroc_1 start_ro
checkretstr 0,2,3,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh skiroc_1 enable_preamp_chans
checkretstr 1,4,5,6,7,8,9,10,11,12,13 ./get_param.sh skiroc_1 disable_preamp_chans
checkretstr 0,1,2,3,4,5,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh skiroc_1 enable_calib_chans
checkretstr 6,7,8,9,10,11,12,13,14,15,16,17,18,19 ./get_param.sh skiroc_1 disable_calib_chans
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31 ./get_param.sh skiroc_1 enable_high_leak_chans
checkretstr 32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh skiroc_1 disable_high_leak_chans
checkretstr 0,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63 ./get_param.sh skiroc_1 allow_trig_chans
checkretstr 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29 ./get_param.sh skiroc_1 disallow_trig_chans
checkretstr ext ./get_param.sh skiroc_1 trig_mode
checkretstr 1 ./get_param.sh skiroc_1 adc_discri
checkretstr 0 ./get_param.sh skiroc_1 auto_gain
checkretstr 1023 ./get_param.sh skiroc_1 dac1_gain
checkretstr high ./get_param.sh skiroc_1 forced_gain
checkretstr 60ns ./get_param.sh skiroc_1 fs_tau
checkretstr 0 ./get_param.sh skiroc_1 gain_select
checkretstr 1 ./get_param.sh skiroc_1 pp_10bit_dual_dac
checkretstr 0 ./get_param.sh skiroc_1 pp_adc_discri
checkretstr 1 ./get_param.sh skiroc_1 pp_adc_ramp
checkretstr 0 ./get_param.sh skiroc_1 pp_bandgap
checkretstr 1 ./get_param.sh skiroc_1 pp_dac4
checkretstr 0 ./get_param.sh skiroc_1 pp_fs
checkretstr 1 ./get_param.sh skiroc_1 pp_gain_select
checkretstr 0 ./get_param.sh skiroc_1 pp_lvds_recv
checkretstr 1 ./get_param.sh skiroc_1 pp_preamp
checkretstr 0 ./get_param.sh skiroc_1 pp_sca
checkretstr 1 ./get_param.sh skiroc_1 pp_ss_g10
checkretstr 0 ./get_param.sh skiroc_1 pp_ss_g1
checkretstr 1 ./get_param.sh skiroc_1 pp_trig_delay
checkretstr 0 ./get_param.sh skiroc_1 pp_trig_discri
checkretstr 1 ./get_param.sh skiroc_1 trig_delay

clean_all
echo "all tests passed"
