#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "SKIROC2CMS TESTS"
echo
cmdmod /opt/pyrame/cmd_cmod.xml -d > cmod.trace 2>&1 &
cmdmod /opt/pyrame/cmd_skiroc2cms.xml > skiroc2cms.trace 2>&1 &
wait_until_awake localhost $CMOD_PORT
wait_until_awake localhost $SKIROC2CMS_PORT
exec_n_test ./load_config_file.sh `pwd`/test.xml
exec_n_test ./init.sh skiroc2cms_1
exec_n_test ./set_chipid_param.sh skiroc2cms_1 15
exec_n_test ./config.sh skiroc2cms_1 `pwd`/skiroc2cms_default.txt undef

checkretstr `cat ref_bs.txt` ./get_param.sh skiroc2cms_1 bitstream
exec_n_test ./explain.sh skiroc2cms_1

#reconfigure
exec_n_test ./config.sh skiroc2cms_1 undef `cat ref_bs.txt`

checkretstr `cat ref_bs.txt` ./get_param.sh skiroc2cms_1 bitstream

clean_all
echo "all tests passed"
