#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "SPIROC2B TESTS"
echo
cmdmod /opt/pyrame/cmd_cmod.xml > cmod.trace 2>&1 &
cmdmod /opt/pyrame/cmd_spiroc2b.xml > spiroc2b.trace 2>&1 &
wait_until_awake localhost $CMOD_PORT
wait_until_awake localhost $SPIROC2B_PORT
exec_n_test ./load_config_file.sh `pwd`/test.xml
exec_n_test ./init.sh spiroc2b_1
exec_n_test ./set_chipid_param.sh spiroc2b_1 14
exec_n_test ./config.sh spiroc2b_1 `pwd`/spiroc2b_default.txt undef undef undef undef undef undef undef undef undef undef undef undef undef

checkretstr 250 ./get_param.sh spiroc2b_1 gtrigger
checkretstr 0 ./get_param.sh spiroc2b_1 bak_sca
checkretstr 20 ./get_param.sh spiroc2b_1 rst_column_delay
checkretstr 1 ./get_param.sh spiroc2b_1 tdc_ext
checkretstr 20 ./get_param.sh spiroc2b_1 trigger_delay
checkretstr 20 ./get_param.sh spiroc2b_1 valid_hold_delay

exec_n_test ./set_gtrigger.sh spiroc2b_1 328
exec_n_test ./set_bak_sca.sh spiroc2b_1 ON
exec_n_test ./disable_preamp.sh spiroc2b_1 0-35
exec_n_test ./enable_preamp.sh spiroc2b_1 2,3,5,7,11,13,17,19,23,29,31
exec_n_test ./disallow_trig.sh spiroc2b_1 all
exec_n_test ./allow_trig.sh spiroc2b_1 2,3,5,7,11,13,17,19,23,29,31
exec_n_test ./set_rst_column_delay.sh spiroc2b_1 13
exec_n_test ./set_tdc_ext.sh spiroc2b_1 OFF
exec_n_test ./set_trigger_delay.sh spiroc2b_1 63
exec_n_test ./set_valid_hold_delay.sh spiroc2b_1 42

checkretstr 328 ./get_param.sh spiroc2b_1 gtrigger
checkretstr 2,3,5,7,11,13,17,19,23,29,31 ./get_param.sh spiroc2b_1 enable_preamp_chans
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32,33,34,35 ./get_param.sh spiroc2b_1 disable_preamp_chans
checkretstr 2,3,5,7,11,13,17,19,23,29,31 ./get_param.sh spiroc2b_1 allow_trig_chans
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32,33,34,35 ./get_param.sh spiroc2b_1 disallow_trig_chans
checkretstr 1 ./get_param.sh spiroc2b_1 bak_sca
checkretstr 13 ./get_param.sh spiroc2b_1 rst_column_delay
checkretstr 0 ./get_param.sh spiroc2b_1 tdc_ext
checkretstr 63 ./get_param.sh spiroc2b_1 trigger_delay
checkretstr 42 ./get_param.sh spiroc2b_1 valid_hold_delay
checkretstr `cat ref_bs.txt` ./get_param.sh spiroc2b_1 bitstream

#reconfigure
exec_n_test ./config.sh spiroc2b_1 undef `cat ref_bs.txt` 329 0-16 17-35 0-5,20-35 6-19 0,2-3,14-35 1,4-13 OFF 57 ON 35 30

checkretstr 329 ./get_param.sh spiroc2b_1 gtrigger
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16 ./get_param.sh spiroc2b_1 allow_trig_chans
checkretstr 17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35 ./get_param.sh spiroc2b_1 disallow_trig_chans
checkretstr 0,1,2,3,4,5,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35 ./get_param.sh spiroc2b_1 enable_preamp_chans
checkretstr 6,7,8,9,10,11,12,13,14,15,16,17,18,19 ./get_param.sh spiroc2b_1 disable_preamp_chans
checkretstr 0,2,3,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35 ./get_param.sh spiroc2b_1 enable_input_dac_chans
checkretstr 1,4,5,6,7,8,9,10,11,12,13 ./get_param.sh spiroc2b_1 disable_input_dac_chans
checkretstr 0 ./get_param.sh spiroc2b_1 bak_sca
checkretstr 57 ./get_param.sh spiroc2b_1 rst_column_delay
checkretstr 1 ./get_param.sh spiroc2b_1 tdc_ext
checkretstr 35 ./get_param.sh spiroc2b_1 trigger_delay
checkretstr 30 ./get_param.sh spiroc2b_1 valid_hold_delay

clean_all
echo "all tests passed"
