#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo 
echo 
echo "SPIROC2D TESTS"
echo
cmdmod /opt/pyrame/cmd_cmod.xml > cmod.trace 2>&1 &
cmdmod /opt/pyrame/cmd_spiroc2d.xml > spiroc2d.trace 2>&1 &
wait_until_awake localhost $CMOD_PORT
wait_until_awake localhost $SPIROC2D_PORT
exec_n_test ./load_config_file.sh `pwd`/test.xml
exec_n_test ./init.sh spiroc2d_1
exec_n_test ./set_chipid_param.sh spiroc2d_1 14
exec_n_test ./config.sh spiroc2d_1 `pwd`/spiroc2d_default.txt undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef undef

checkretstr 250 ./get_param.sh spiroc2d_1 gtrigger
checkretstr 0 ./get_param.sh spiroc2d_1 bak_sca
checkretstr 20 ./get_param.sh spiroc2d_1 rst_column_delay
checkretstr 0 ./get_param.sh spiroc2d_1 tdc_ext
checkretstr 20 ./get_param.sh spiroc2d_1 trigger_delay
checkretstr 20 ./get_param.sh spiroc2d_1 valid_hold_delay
checkretstr 12bit ./get_param.sh spiroc2d_1 adc_ramp_slope
checkretstr 0 ./get_param.sh spiroc2d_1 auto_gain
checkretstr high ./get_param.sh spiroc2d_1 forced_gain
checkretstr 0 ./get_param.sh spiroc2d_1 dac2_gain_select
checkretstr 1 ./get_param.sh spiroc2d_1 dac2
checkretstr high ./get_param.sh spiroc2d_1 fs_gain
checkretstr 1 ./get_param.sh spiroc2d_1 lvds_notrig
checkretstr 1 ./get_param.sh spiroc2d_1 lvds_trigext
checkretstr 1 ./get_param.sh spiroc2d_1 lvds_valevt
checkretstr 0  ./get_param.sh spiroc2d_1 pp_dac2
checkretstr fast ./get_param.sh spiroc2d_1 tdc_ramp_slope
checkretstr 1 ./get_param.sh spiroc2d_1 tdc

exec_n_test ./set_gtrigger.sh spiroc2d_1 328
exec_n_test ./set_bak_sca.sh spiroc2d_1 ON
exec_n_test ./disable_preamp.sh spiroc2d_1 0-35
exec_n_test ./enable_preamp.sh spiroc2d_1 2,3,5,7,11,13,17,19,23,29,31
exec_n_test ./disallow_trig.sh spiroc2d_1 all
exec_n_test ./allow_trig.sh spiroc2d_1 2,3,5,7,11,13,17,19,23,29,31
exec_n_test ./set_rst_column_delay.sh spiroc2d_1 13
exec_n_test ./set_tdc_ext.sh spiroc2d_1 OFF
exec_n_test ./set_trigger_delay.sh spiroc2d_1 63
exec_n_test ./set_valid_hold_delay.sh spiroc2d_1 42

checkretstr 328 ./get_param.sh spiroc2d_1 gtrigger
checkretstr 2,3,5,7,11,13,17,19,23,29,31 ./get_param.sh spiroc2d_1 enable_preamp_chans
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32,33,34,35 ./get_param.sh spiroc2d_1 disable_preamp_chans
checkretstr 2,3,5,7,11,13,17,19,23,29,31 ./get_param.sh spiroc2d_1 allow_trig_chans
checkretstr 0,1,4,6,8,9,10,12,14,15,16,18,20,21,22,24,25,26,27,28,30,32,33,34,35 ./get_param.sh spiroc2d_1 disallow_trig_chans
checkretstr 1 ./get_param.sh spiroc2d_1 bak_sca
checkretstr 13 ./get_param.sh spiroc2d_1 rst_column_delay
checkretstr 0 ./get_param.sh spiroc2d_1 tdc_ext
checkretstr 63 ./get_param.sh spiroc2d_1 trigger_delay
checkretstr 42 ./get_param.sh spiroc2d_1 valid_hold_delay


exec_n_test ./set_adc_ramp_slope.sh spiroc2d_1 8bit
exec_n_test ./set_auto_gain.sh spiroc2d_1 1
exec_n_test ./set_forced_gain.sh spiroc2d_1 low
exec_n_test ./set_dac2_gain_select.sh spiroc2d_1 1023
exec_n_test ./set_dac2.sh spiroc2d_1 0
exec_n_test ./set_fs_gain.sh spiroc2d_1 low
exec_n_test ./set_lvds_notrig.sh spiroc2d_1 0
exec_n_test ./set_lvds_trigext.sh spiroc2d_1 1
exec_n_test ./set_lvds_valevt.sh spiroc2d_1 0
exec_n_test ./set_pp_dac2.sh spiroc2d_1 1
exec_n_test ./set_tdc_ramp_slope.sh spiroc2d_1 slow
exec_n_test ./set_tdc.sh spiroc2d_1 0

checkretstr `cat ref_bs.txt` ./get_param.sh spiroc2d_1 bitstream


#reconfigure
exec_n_test ./config.sh spiroc2d_1 undef `cat ref_bs.txt` 329 0-16 17-35 0-5,20-35 6-19 0,2-3,14-35 1,4-13 OFF 57 ON 35 30 10bit 0 high 628 1 high 1 0 1 0 fast 1

checkretstr 329 ./get_param.sh spiroc2d_1 gtrigger
checkretstr 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16 ./get_param.sh spiroc2d_1 allow_trig_chans
checkretstr 17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35 ./get_param.sh spiroc2d_1 disallow_trig_chans
checkretstr 0,1,2,3,4,5,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35 ./get_param.sh spiroc2d_1 enable_preamp_chans
checkretstr 6,7,8,9,10,11,12,13,14,15,16,17,18,19 ./get_param.sh spiroc2d_1 disable_preamp_chans
checkretstr 0,2,3,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35 ./get_param.sh spiroc2d_1 enable_input_dac_chans
checkretstr 1,4,5,6,7,8,9,10,11,12,13 ./get_param.sh spiroc2d_1 disable_input_dac_chans
checkretstr 0 ./get_param.sh spiroc2d_1 bak_sca
checkretstr 57 ./get_param.sh spiroc2d_1 rst_column_delay
checkretstr 1 ./get_param.sh spiroc2d_1 tdc_ext
checkretstr 35 ./get_param.sh spiroc2d_1 trigger_delay
checkretstr 30 ./get_param.sh spiroc2d_1 valid_hold_delay



for i in `seq 0 35`; do
  discri=$((i+10))
  input=$((i+50))
  exec_n_test ./set_discri_dac.sh spiroc2d_1 $i $discri
  checkretstr $((discri%16)) ./extract_discri_dac.sh spiroc2d_1 $i
  exec_n_test ./set_input_dac.sh spiroc2d_1 $i $input
  checkretstr $input ./extract_input_dac.sh spiroc2d_1 $i
done

checkretstr 10bit ./get_param.sh spiroc2d_1 adc_ramp_slope
checkretstr 0 ./get_param.sh spiroc2d_1 auto_gain
checkretstr high ./get_param.sh spiroc2d_1 forced_gain
checkretstr 628 ./get_param.sh spiroc2d_1 dac2_gain_select
checkretstr 1 ./get_param.sh spiroc2d_1 dac2
checkretstr high ./get_param.sh spiroc2d_1 fs_gain
checkretstr 1 ./get_param.sh spiroc2d_1 lvds_notrig
checkretstr 0 ./get_param.sh spiroc2d_1 lvds_trigext
checkretstr 1 ./get_param.sh spiroc2d_1 lvds_valevt
checkretstr 0  ./get_param.sh spiroc2d_1 pp_dac2
checkretstr fast ./get_param.sh spiroc2d_1 tdc_ramp_slope
checkretstr 1 ./get_param.sh spiroc2d_1 tdc
checkretstr `cat ref2_bs.txt` ./get_param.sh spiroc2d_1 bitstream
exec_n_test ./explain.sh spiroc2d_1

clean_all
echo "all tests passed"
