#!/usr/bin/env python2

import sys,subprocess,time
import couchdb

def execcmd(command,err_msg,ignore_errors=False):
    result=subprocess.Popen(command,stdout=subprocess.PIPE,stderr=subprocess.STDOUT,shell=True)
    res,_=result.communicate()
    if result.returncode!=0:
        print(res)
        print(err_msg)
        if not ignore_errors:
            sys.exit(1)
    return res

# get CouchDB db-dir
db_dir=execcmd("couch-config --db-dir","error getting couchdb db-dir")
db_dir=db_dir.strip()

# stop Pyrame
print("stopping Pyrame")
execcmd("kill_pyrame.sh","error killing pyrame")

# stop CouchDB
print("stopping CouchDB")
execcmd("systemctl stop couchdb","error stopping couchdb",True)
execcmd("/etc/init.d/couchdb stop","error stopping couchdb")

# backup db
print("backing up db")
command="if ! test -d %s.bak; then cp -a %s %s.bak; fi"%(db_dir,db_dir,db_dir)
execcmd(command,"error backing up db")

# start CouchDB
print("starting CouchDB")
execcmd("/etc/init.d/couchdb start","error starting couchdb")

time.sleep(2)

cdbs=couchdb.Server()

acq_db=cdbs["acqs"]
run_db=cdbs["runs"]
run_g_db=cdbs["run_groups"]

# stock root_path and remove it from root
root_path=run_g_db["root"]["path"].rstrip("/")

# add path to all elements
def new_id(old_id,root_path):
    return "root/prototech%s"%(old_id[len(root_path):])

def update_db(doc_type,db,group_name):
    print("updating %s db..."%(doc_type))
    els=db.view("_design/basic/_view/%s_name"%(doc_type))
    for e in els:
        if e.id=="root":
            continue
        #print("treating %s %s"%(doc_type,e.id))
        old_e=db[e.id]
        old_e["mp"]="file:///"
        old_e["path"]=e.id.lstrip("/")
        old_e[group_name]=new_id(old_e[group_name],root_path)
        nid=new_id(e.id,root_path)
        db[nid]=old_e
        db.purge([db[e.id]])

update_db("acq",acq_db,"run_id")
update_db("run",run_db,"run_g_id")
update_db("run_g",run_g_db,"run_g_id")

run_g_db["root/prototech"]={"name":"prototech","mp":"file:///","path":"home/data/prototech","run_g_id":"root"}
doc=run_g_db["root"]
del doc["path"]
run_g_db["root"]=doc

# move data from root_path to root_path/prototech
print("moving data from %s to %s/prototech"%(root_path,root_path))
command="mkdir -p %s/prototech; mv %s/* %s/prototech/"%(root_path,root_path,root_path)
execcmd(command,"error moving data",True)

acq_db.compact()
run_db.compact()
run_g_db.compact()
