#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh

RUN_G=unit_test_run_group
RUN_G_PATH=home/data/unit_test_run_group
RUN=unit_test_run
RUN_PATH=home/data/unit_test_run
ACQ_1=unit_test_acq1
ACQ_1_PATH=home/data/unit_test_acq1
ACQ_2=unit_test_acq2
ACQ_2_PATH=home/data/unit_test_acq2
MP=file:///

# clean up unit_test residues
./del_run_group.sh root/$RUN_G true
./del_run.sh root/$RUN true

# create run group and run
exec_n_test ./new_run_group.sh $RUN_G $MP $RUN_G_PATH root
RUN_G_ID=$RETSTR
exec_n_test ./new_run.sh $RUN $MP $RUN_PATH $RUN_G_ID
RUN_ID=$RETSTR
exec_n_test ./new_acq.sh $ACQ_1 $MP $ACQ_1_PATH $RUN_ID
ACQ_ID1=$RETSTR
exec_n_test ./new_acq.sh $ACQ_2 $MP $ACQ_2_PATH $RUN_ID
ACQ_ID2=$RETSTR

# set params
exec_n_test ./set_param_acq.sh $ACQ_ID1 name1 value1
exec_n_test ./set_param_acq.sh $ACQ_ID2 name2 value2

# search db
checkretstr $ACQ_ID1,$ACQ_ID2 ./get_acqs_regex.sh name value
checkretstr $ACQ_ID1 ./get_acqs_regex.sh name value1
checkretstr $ACQ_ID2 ./get_acqs_regex.sh name2 value2
checkretlist $ACQ_ID1,$ACQ_ID2 ./get_acqs_regex.sh name "unit_test_acq[12]"
#checkretlist $ACQ_ID1,$ACQ_ID2 ./get_acqs_script.sh "<![CDATA[function(doc) { var key_re = new RegExp(\"name\"); var value_re = new RegExp(\"unit_test_acq[12]\"); for (var key in doc) { if (key.search(key_re)!=-1 && doc[key].search(value_re)!=-1) { emit(key,doc[key]); } } }]]>" none false

# get acqs
exec_n_test ./get_acqs_table_regex.sh name "unit_test_acq[12]"
check_pattern "name	$ACQ_1" "`echo "$RETSTR" | base64 -d -`"
check_pattern "name	$ACQ_2" "`echo "$RETSTR" | base64 -d -`"

# remove run group and run
exec_n_test ./del_run_group.sh $RUN_G_ID true
rm -rf /$RUN_G_PATH
