#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh

RUN_G=unit_test_run_group
RUN_G_PATH=home/data/$RUN_G
RUN=unit_test_run
RUN_PATH=$RUN_G_PATH/$RUN
ACQ=unit_test_acq
ACQ_PATH=$RUN_PATH
MP=file:///

# clean up unit_test residues
./del_run_group.sh root/$RUN_G true
./del_run.sh root/$RUN true

# create run group and run
exec_n_test ./new_run_group.sh $RUN_G $MP $RUN_G_PATH root
RUN_G_ID=$RETSTR
exec_n_test ./new_run.sh $RUN $MP $RUN_PATH $RUN_G_ID
RUN_ID=$RETSTR
exec_n_test ./new_acq.sh $ACQ $MP $ACQ_PATH $RUN_ID
ACQ_ID=$RETSTR

# set params
exec_n_test_fail ./set_param_acq.sh $ACQ_ID name value1
exec_n_test_fail ./set_param_acq.sh $ACQ_ID run_id value2

exec_n_test ./set_param_acq.sh $ACQ_ID name1 value1
check_pattern_in_file '"name1": "value1"' /$ACQ_PATH/${ACQ}_acq_rundb_dump.json

exec_n_test ./set_param_acq.sh root/$RUN_G/$RUN/$ACQ name2 value2
check_pattern_in_file '"name2": "value2"' /$ACQ_PATH/${ACQ}_acq_rundb_dump.json

exec_n_test_fail ./set_xml_params_acq.sh $ACQ_ID inexistant_file.xml true

exec_n_test ./set_xml_params_acq.sh $ACQ_ID ../rc/scripts/test_rc.xml true
check_pattern_in_file '"localhost#domain_nb_skiroc": "16"' /$ACQ_PATH/${ACQ}_acq_rundb_dump.json

# get param
checkretstr value1 ./get_param_acq.sh root/$RUN_G/$RUN/$ACQ name1
checkretstr value2 ./get_param_acq.sh $ACQ_ID name2
exec_n_test_fail ./get_param_acq.sh $ACQ_ID name3
checkretstr 16 ./get_param_acq.sh $ACQ_ID "localhost#domain_nb_skiroc"

# get params
exec_n_test_fail ./get_params_acq.sh $ACQ_ID$ACQ_ID
checkretlist "storage#storage_producers_count,storage#storage_stats_names,run_id,test_smtest#skiroc_bitstream,name2,localhost#domain_ip,name1,storage#storage_use_rundb,storage#storage_mode,storage#storage_convert_script,name,localhost#domain_nb_skiroc,storage#storage_brg_name,test_smtest#smtest_roctype,storage#storage_brg_path,mp,storage#storage_elog_server,path,storage#storage_elog_name,storage#storage_brg_mp" ./get_params_acq.sh $ACQ_ID

# remove run group and run
exec_n_test ./del_run_group.sh $RUN_G_ID true
rm -rf /$RUN_G_PATH
