#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh

RUN_G=unit_test_run_group
RUN_G_PATH=home/data/$RUN_G
RUN=unit_test_run
RUN_PATH=$RUN_G_PATH/$RUN
MP=file:///

# clean up unit_test residues
./del_run_group.sh root/$RUN_G true
./del_run.sh root/$RUN true

# create run group and run
exec_n_test ./new_run_group.sh $RUN_G $MP $RUN_G_PATH root
RUN_G_ID=$RETSTR
exec_n_test ./new_run.sh $RUN $MP $RUN_PATH $RUN_G_ID
RUN_ID=$RETSTR

# set params
# fail on reserved param names
exec_n_test_fail ./set_param_run.sh $RUN_ID name value1
exec_n_test_fail ./set_param_run.sh $RUN_ID run_g_id value2

exec_n_test ./set_param_run.sh $RUN_ID name1 value1
check_pattern_in_file '"name1": "value1"' /$RUN_PATH/${RUN}_run_rundb_dump.json

exec_n_test ./set_param_run.sh root/$RUN_G/$RUN name2 value2
check_pattern_in_file '"name2": "value2"' /$RUN_PATH/${RUN}_run_rundb_dump.json

# get param
exec_n_test_fail ./get_param_run.sh root/$RUN_G/$RUN name3
checkretstr value1 ./get_param_run.sh root/$RUN_G/$RUN name1
checkretstr value2 ./get_param_run.sh $RUN_ID name2

# remove run group and run
exec_n_test ./del_run_group.sh $RUN_G_ID true
rm -rf /$RUN_G_PATH
