#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh

RUN_G=unit_test_run_group
RUN_G_PATH=home/data/$RUN_G
RUN=unit_test_run
RUN_PATH=$RUN_G_PATH/$RUN
NOW=`date -u +%Y%m%d-%H%M%S`
ACQ_1_BASENAME=unit_test_acq
ACQ_1=$NOW/$ACQ_1_BASENAME
ACQ_1_PATH=$RUN_PATH/$NOW
ACQ_2=unit_test_acq
ACQ_2_PATH=$RUN_PATH
MP=file:///

# clean up unit_test residues
./del_run_group.sh root/unit_test_run_group true
./del_run.sh root/unit_test_run true

# create run group and run
exec_n_test ./new_run_group.sh $RUN_G $MP $RUN_G_PATH root
RUN_G_ID=$RETSTR
exec_n_test ./new_run.sh $RUN $MP $RUN_PATH $RUN_G_ID
RUN_ID=$RETSTR

# new
exec_n_test ./new_acq.sh $ACQ_1 $MP $ACQ_1_PATH $RUN_ID
ACQ_ID1=$RETSTR
exec_n_test ./new_acq.sh $ACQ_2 $MP $ACQ_2_PATH $RUN_ID
ACQ_ID2=$RETSTR
# test append mode
exec_n_test_fail ./new_acq.sh $ACQ_1 $MP $ACQ_1_PATH $RUN_ID
# test remove mode 
exec_n_test ./new_acq.sh $ACQ_1 $MP $ACQ_1_PATH $RUN_ID remove
# check json backup
check_exist_file /$ACQ_1_PATH/${ACQ_1_BASENAME}_acq_rundb_dump.json

# check existance
exec_n_test_fail ./get_acq_name.sh $ACQ_ID1$ACQ_ID1
checkretstr $ACQ_1 ./get_acq_name.sh $ACQ_ID1
checkretstr $ACQ_ID1 ./check_acq_id.sh $ACQ_ID1
checkretstr $ACQ_ID1 ./check_acq_id.sh root/$RUN_G/$RUN/$ACQ_1

# get acqs in run
exec_n_test_fail ./get_acqs_in_run.sh root/$RUN_G/$RUN$RUN false
checkretlist "$ACQ_1,$ACQ_2" ./get_acqs_in_run.sh root/$RUN_G/$RUN false

# delete acq
exec_n_test ./del_acq.sh root/$RUN_G/$RUN/$ACQ_1
exec_n_test ./del_acq.sh root/$RUN_G/$RUN/$ACQ_2
exec_n_test_fail ./del_acq.sh root/$RUN_G/$RUN/$ACQ_1
exec_n_test_fail ./check_run_id.sh $ACQ_ID1
rm -rf /$ACQ_1_PATH

# remove run group and run
exec_n_test ./del_run.sh $RUN_ID false
exec_n_test ./del_run_group.sh $RUN_G_ID false
rm -rf /$RUN_G_PATH
