#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh

RUN_G=unit_test_run_group
RUN_G_PATH=home/data/$RUN_G
RUN=unit_test_run_`date -u +%Y%m%d-%H%M%S`-UTC
RUN_PATH=home/data/$RUN
RUN_2=unit_test_run_`date -u +%Y%m%d-%H%M%S`-UTC
RUN_2_PATH=$RUN_G_PATH/$RUN_2
ACQ=unit_test_acq
ACQ_PATH=$RUN_2_PATH
MP=file:///

# clean up unit_test residues
./del_run_group.sh root/$RUN_G true
./del_run.sh root/$RUN true

# create run group
exec_n_test ./new_run_group.sh $RUN_G $MP $RUN_G_PATH root
RUN_G_ID=$RETSTR

# IN ROOT

# new - same name as run group
exec_n_test_fail ./new_run.sh $RUN_G $MP $RUN_PATH root
# new - with dir
exec_n_test_fail ./new_run.sh /$RUN $MP $RUN_PATH root
exec_n_test ./new_run.sh $RUN $MP $RUN_PATH root
RUN_ID=$RETSTR
check_exist_file /$RUN_PATH/${RUN}_run_rundb_dump.json

# check existance
checkretstr $RUN_ID ./check_run_id.sh $RUN_ID
checkretstr $RUN_ID ./check_run_id.sh root/$RUN
exec_n_test_fail ./check_run_id.sh /$RUN

# check conflict detection
exec_n_test_fail ./new_run_group.sh $RUN $MP $RUN_PATH root

# get run in run group
exec_n_test_fail ./get_runs_in_run_group.sh $RUN_ID$RUN_ID
checkretstrpattern $RUN_ID ./get_runs_in_run_group.sh root

# delete run
exec_n_test ./del_run.sh $RUN_ID true
# fail because already deleted
exec_n_test_fail ./del_run.sh $RUN_ID true
exec_n_test_fail ./check_run_id.sh $RUN_ID
rm -rf /$RUN_PATH

# IN RUN GROUP unit_test_run_group

# new
exec_n_test ./new_run.sh $RUN_2 $MP $RUN_2_PATH $RUN_G_ID
# test append mode
exec_n_test ./new_run.sh $RUN_2 $MP $RUN_2_PATH $RUN_G_ID
# test remove mode
exec_n_test ./new_run.sh $RUN_2 $MP $RUN_2_PATH $RUN_G_ID remove
RUN_ID2=$RETSTR

# check existance
exec_n_test_fail ./get_run_name.sh $RUN_ID2$RUN_ID2
checkretstr $RUN ./get_run_name.sh $RUN_ID2
checkretstr $RUN_ID2 ./check_run_id.sh $RUN_ID2
checkretstr $RUN_ID2 ./check_run_id.sh root/$RUN_G/$RUN_2

# get run in run group
checkretstr $RUN_ID2 ./get_runs_in_run_group.sh $RUN_G_ID

# delete run
exec_n_test ./del_run.sh root/$RUN_G/$RUN_2 true
exec_n_test_fail ./check_run_id.sh $RUN_ID2
rm -rf /$RUN_2_PATH

# DELETE with one acq inside
exec_n_test ./new_run.sh $RUN_2 $MP $RUN_2_PATH $RUN_G_ID
exec_n_test ./new_acq.sh $ACQ $MP $ACQ_PATH root/$RUN_G/$RUN_2
exec_n_test_fail ./del_run.sh root/$RUN_G/$RUN_2 false
exec_n_test ./del_run.sh root/$RUN_G/$RUN_2 true
rm -rf /$ACQ_PATH

# remove run group
exec_n_test ./del_run_group.sh $RUN_G_ID false
rm -rf /$RUN_G_PATH
