#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh

RUN_G=unit_test_run_group
RUN_G_PATH=home/data/$RUN_G
RUN_G_2=`date -u +%Y%m%d-%H%M%S`-UTC
RUN_G_2_PATH=home/data/$RUN_G/$RUN_G_2
RUN_G_3=dirtest
RUN_G_3_PATH=home/data/$RUN_G/$RUN_G_2/$RUN_G_3
RUN=unit_test_run
RUN_PATH=$RUN_G_2_PATH/$RUN
ACQ=unit_test_acq
ACQ_PATH=$RUN_PATH
MP=file:///

# clean up unit_test residues
./del_run_group.sh root/$RUN_G true
./del_run.sh root/$RUN true

# new - run group in root run group
exec_n_test ./new_run_group.sh $RUN_G $MP $RUN_G_PATH root
RUN_G_ID=$RETSTR
# in default append mode we don't delete the current run group
checkretstr $RUN_G_ID ./new_run_group.sh $RUN_G $MP $RUN_G_PATH root
# in remove mode we remove existing run group
exec_n_test ./new_run_group.sh $RUN_G $MP $RUN_G_PATH root remove
check_exist_file /$RUN_G_PATH/${RUN_G}_run_g_rundb_dump.json
check_file_size 191 /$RUN_G_PATH/${RUN_G}_run_g_rundb_dump.json

# check existance
checkretstr $RUN_G_ID ./check_run_g_id.sh $RUN_G_ID
checkretstr $RUN_G_ID ./check_run_g_id.sh root/$RUN_G
exec_n_test_fail ./check_run_g_id.sh $RUN_G

# new
exec_n_test ./new_run_group.sh $RUN_G_2 $MP $RUN_G_2_PATH $RUN_G_ID
RUN_G_ID2=$RETSTR

# check existance
checkretstr $RUN_G_ID2 ./check_run_g_id.sh $RUN_G_ID2
checkretstr $RUN_G_ID2 ./check_run_g_id.sh root/$RUN_G/$RUN_G_2

# new - 3rd level
exec_n_test ./new_run_group.sh $RUN_G_3 $MP $RUN_G_3_PATH root/$RUN_G/$RUN_G_2
RUN_G_ID3=$RETSTR

# check existance
exec_n_test_fail ./get_run_group_name.sh $RUN_G_ID3$RUN_G_ID3
checkretstr $RUN_G_3 ./get_run_group_name.sh $RUN_G_ID3
checkretstr $RUN_G_ID3 ./check_run_g_id.sh $RUN_G_ID3
checkretstr $RUN_G_ID3 ./check_run_g_id.sh root/$RUN_G/$RUN_G_2/$RUN_G_3

# get run groups in run groups
exec_n_test_fail ./get_run_groups_in_run_group.sh $RUN_G_ID$RUN_G_ID
exec_n_test ./get_run_groups_in_run_group.sh root true
R_GROUPS=$RETSTR
check_pattern $RUN_G_ID $R_GROUPS
check_pattern $RUN_G_ID2 $R_GROUPS
check_pattern $RUN_G_ID3 $R_GROUPS

# del - all
# fail because not empty
exec_n_test_fail ./del_run_group.sh root/$RUN_G/$RUN_G_2 false
exec_n_test ./del_run_group.sh root/$RUN_G/$RUN_G_2 true
# fail because we just deleted it
exec_n_test_fail ./del_run_group.sh root/$RUN_G/$RUN_G_2 true
exec_n_test_fail ./check_run_g_id.sh $RUN_G_ID2
exec_n_test_fail ./check_run_g_id.sh $RUN_G_ID3
rm -rf /$RUN_G_2_PATH

# del - recursive
exec_n_test ./new_run_group.sh $RUN_G_2 $MP $RUN_G_2_PATH $RUN_G_ID
exec_n_test ./new_run.sh $RUN $MP $RUN_G_PATH root/$RUN_G/$RUN_G_2
RUN_ID=$RETSTR
exec_n_test ./new_acq.sh $ACQ $MP $ACQ_PATH root/$RUN_G/$RUN_G_2/$RUN
ACQ_ID=$RETSTR
# fail because not empty
exec_n_test_fail ./del_run_group.sh root/$RUN_G/$RUN_G_2 false
exec_n_test ./del_run_group.sh root/$RUN_G/$RUN_G_2 true
# fail because we just deleted it recursively
exec_n_test_fail ./check_run_id.sh $RUN_ID
exec_n_test_fail ./check_acq_id.sh $ACQ_ID

# delete ALL
exec_n_test ./del_run_group.sh $RUN_G_ID false
rm -rf /$RUN_G_PATH
