#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

import xml.parsers.expat

def sbool(value):
    if value.lower() in ["true","1","on","yes"]:
        return 1
    return 0


class xml_param_parser():

    def start_el(self,name,attrs):
        if name=="param" and self.current_name==None and "name" in attrs:
            #print("start el: %s,%s"%(name,attrs))
            self.current_name=attrs["name"]
        elif "name" in attrs:
            self.elements_stack.append(attrs["name"])

    def char_data(self,data):
        if self.current_name!=None:
            #print("data: %s"%(data))
            self.current_data+=data

    def end_el(self,name):
        if name=="param" and self.current_name!=None:
            #print("end el: %s"%(name))
            if sbool(self.add_parent):
                self.params[self.elements_stack[-1]+"#"+self.current_name]=self.current_data
            else:
                self.params[self.current_name]=self.current_data
            self.current_name=None
            self.current_data=""
        else:
            self.elements_stack.pop()
            #self.current_el=""

    def parse(self,string,add_parent):
        self.p = xml.parsers.expat.ParserCreate()
        self.p.StartElementHandler = self.start_el
        self.p.EndElementHandler = self.end_el
        self.p.CharacterDataHandler = self.char_data
        self.params={}
        self.elements_stack=[]
        self.current_name=None
        self.current_data=""
        self.add_parent=add_parent
        self.p.Parse(string)
        return self.params
