

#include <string.h>
#include <cmdmod_helper.h>

void *init(int argc,char **argv) {
  //struct cmd_result *cres;
  int i;
  printf("init module\n");
  if (argc!=0) {
    for(i=0;i<argc;i++) {
      printf("argument %d = %s\n",i,argv[i]);
    }
  }
  //cres=submod_setmyport(9007);
  //free_cmd_result(cres);
  return NULL;
}

//pyrapi:segfault_test:
struct cmd_result *segfault_test(struct cmd *command,void *workspace) {
  char *nullp=NULL;
  int a=1;
  a=*nullp;
  printf("%d\n",a);
  return raw_build_result(1,"never reached");
}

struct cmd_result *setres_test(struct cmd *command,void *workspace) {
  int i=34;
  return build_result(1,"magic number is %d",i);
}

//pyrapi:void_test:
struct cmd_result *void_test(struct cmd *command,void *workspace) {
  //printf("inside void c code\n");
  //printf("declare x with value 2 result=%d\n",submod_declare(1,"x",strdup("2"),0));
  //printf("get back x value=%s\n",submod_get(1,"x"));
  //printf("change x value to 3 result=%d\n",submod_set(1,"x",strdup("3")));
  //printf("get back x value=%s\n",submod_get(1,"x"));
  return raw_build_result(1,"void()");
}

//pyrapi:getmyport_test:
struct cmd_result *getmyport_test(struct cmd *command,void *workspace) {
  return submod_getmyport();
}

//pyrapi:getmyfile_test:
struct cmd_result *getmyfile_test(struct cmd *command,void *workspace) {
  return submod_getmyfile();
}

//pyrapi:onearg_test:arg1
struct cmd_result *onearg_test(struct cmd *command,void *workspace) {
  if (command->nb_params!=1) {
    return build_result(0,"1 arg needed : %d provided",command->nb_params);
  } else {
    return build_result(1,"onearg(%s)",command->params[0]);
  }
}

//pyrapi:twoargs_test:arg1,arg2
struct cmd_result *twoargs_test(struct cmd *command,void *workspace) {
  if (command->nb_params!=2) {
    return build_result(0,"2 arg needed : %d provided",command->nb_params);
  } else {
    return build_result(1,"twoargs(%s,%s)",command->params[0],command->params[1]);
  }
}

//pyrapi:fail_test:
struct cmd_result *fail_test(struct cmd *command,void *workspace) {
  return raw_build_result(0,"fail()");
}

//pyrapi:varmod_test:
struct cmd_result *varmod_test(struct cmd *command,void *workspace) {
  struct cmd_result *vres;
  struct cmd_result *cres;
  vres=submod_execcmd("setvar@varmod","id","default","x","2","end");
  if (vres->retcode==0) {
    cres=build_result(0,"cant setvar <- %s",vres->str);
    free_cmd_result(vres);
    return cres;
  }
  free_cmd_result(vres);
  return raw_build_result(1,"ok");
}

//pyrapi:res_to_varmod_test:
struct cmd_result *res_to_varmod_test(struct cmd *command,void *workspace) {
  struct cmd_result *cres;
  struct cmd_result *vres;
  vres=submod_execcmd("setvar@varmod","id","default","res_retcode",command->params[0],"end");
  if (vres->retcode==0) {
     cres=build_result(0,"cant setvar <- %s",vres->str);
     free_cmd_result(vres);
     return cres;
  }
  free_cmd_result(vres);
  vres=submod_execcmd("setvar@varmod","id","default","res_str",command->params[1],"end");
  if (vres->retcode==0) {
    cres=build_result(0,"cant setvar <- %s",vres->str);
    free_cmd_result(vres);
    return cres;
  }
  free_cmd_result(vres);
  return raw_build_result(1,"ok");
}


void *asyncwait_t(void *env) {
  struct bg_ws *bg_context=(struct bg_ws *)env;
  int time=*((int *)bg_context->params);
  free(bg_context->params);
  //printf("in the thread, waiting for %d seconds\n",time);
  sleep(time);
  submod_sendres(bg_context,build_result(1,"ok"));
  return NULL;
}

//pyrapi:asyncwait_test:time
struct cmd_result *asyncwait_test(struct cmd *command,void *workspace) {
  pthread_t *t_aw;
  struct bg_ws *bg_context=submod_bgcontext();
  int *ptime=malloc(sizeof(int));
  *ptime=atoi(command->params[0]);
  bg_context->params=(void *)ptime;
  t_aw=(pthread_t*)malloc(sizeof(pthread_t));
  if (pthread_create(t_aw,NULL,asyncwait_t,(void *)bg_context)<0) {
    perror("pthread_create");
    cexit(8);
  }
  pthread_detach(*t_aw);
  return build_result(KEEPOPEN,"ok");
}
