
#include <string>
#include <string.h>
#include <iostream> 
#include <sstream>
#include <cmdmod_helper.hpp>

extern "C" void *init();
void *init() {
  std::cout<<"init module"<<std::endl;
  submod_setmyport(9007);
  return NULL;
}

//pyrapi:void_test:
extern "C" struct cmd_result *void_test(struct cmd *,void *);
struct cmd_result *void_test(struct cmd *command,void *workspace) {
  //std::cout<<"inside c++ void code"<<std::endl;
  return raw_build_result(1,"void()");
}

//pyrapi:getmyport_test:
extern "C" struct cmd_result *getmyport_test(struct cmd *,void *);
struct cmd_result *getmyport_test(struct cmd *command,void *workspace) {
  return submod_getmyport();
}

//pyrapi:getmyfile_test:
extern "C" struct cmd_result *getmyfile_test(struct cmd *,void *);
struct cmd_result *getmyfile_test(struct cmd *command,void *workspace) {
  return submod_getmyfile();
}

//pyrapi:onearg_test:arg1
extern "C" struct cmd_result *onearg_test(struct cmd *,void *);
struct cmd_result *onearg_test(struct cmd *command,void *workspace) {
  if (command->nb_params!=1) {
    return build_result(0,"1 arg needed, %d given",command->nb_params);
  } else {
    return build_result(1,"onearg(%s)",command->params[0]);
  }
}

//pyrapi:twoargs_test:arg1,arg2
extern "C" struct cmd_result *twoargs_test(struct cmd *command,void *workspace);
struct cmd_result *twoargs_test(struct cmd *command,void *) {
  if (command->nb_params!=2) {
    return build_result(0,"2 args needed, %d given",command->nb_params);
  } else {
    return build_result(1,"twoargs(%s,%s)",command->params[0],command->params[1]);
  }
}

//pyrapi:fail_test:
extern "C" struct cmd_result *fail_test(struct cmd *command,void *workspace);
struct cmd_result *fail_test(struct cmd *command,void *) {
  return raw_build_result(0,"fail()");
}

//pyrapi:varmod_test:
extern "C" struct cmd_result *varmod_test(struct cmd *command,void *workspace);
struct cmd_result *varmod_test(struct cmd *command,void *) {
  struct cmd_result *cres;
  cres=submod_execcmd((char*)"setvar@varmod","id","default",(char*)"x",(char*)"2",(char*)"end");
  if (cres->retcode==0) {
    free_cmd_result(cres);
     return raw_build_result(0,"cant setvar");
  }
  free_cmd_result(cres);
  return raw_build_result(1,"ok");
}
    
