#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2015 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
# 
# Pyrame is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Pyrame is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with Pyrame.  If not, see <http://www.gnu.org/licenses/>

import time,threading
import pools,apipools
mypool=pools.pool()
myapipool=apipools.api_pool()

def exception():
   int("a") 

def init(*params):
    i=0
    print("module init")
    for param in params:
        print("argument %d = %s"%(i,param))
        i+=1
    submod_setmyport(9007)

#pyrapi:init_test:dev_name,arg1,arg2,arg3
def init_test(dev_name,arg1,arg2,arg3):
   print("arg1=%s arg2=%s arg3=%s"%(arg1,arg2,arg3))
   return submod_newns(dev_name)

#pyrapi:void_test:
def void_test():
   return 1,"void()"

#pyrapi:wakemeup_test:
def wakemeup_test():
   return submod_wakemeup(1000000,"onearg_test","test_wmu")

#pyrapi:getmyport_test:
def getmyport_test():
    return submod_getmyport()

#pyrapi:gettestport_test:
def gettestport_test():
    port=submod_getport("test")
    return 1,str(port)

#pyrapi:getmyfile_test:
def getmyfile_test():
    return submod_getmyfile()

#pyrapi:cmod_resolve_test:
def cmod_resolve_test():
    retcode,res=submod_execcmd("newns@varmod","varmod","id")
    if retcode==0:
        return 0,"cant newns <- %s"%(res)
    retcode,res=submod_execcmd("setvar@varmod","varmod","id","y","2")
    if retcode==0:
        return 0,"cant setvar <- %s"%(res)
    # intopvar_varmod not included as host function in xml file
    retcode,res=submod_execcmd("intopvar@varmod","varmod","id","y","+","3")
    if retcode==0:
        return 0,"cant intopvar <- %s"%(res)
    retcode,res=submod_execcmd("getvar@varmod","varmod","id","y")
    if retcode==0:
        return 0,"cant getvar <- %s"%(res)
    if res!="5":
        return 0,"wrong y value in varmod"
    return 1,"ok"
 
#pyrapi:fail_test:
def fail_test():
    return 0,"fail()"

#pyrapi:onearg_test:arg1
def onearg_test(arg1):
    return 1,"onearg(%s)"%(arg1)

#pyrapi:twoargs_test:arg1,arg2
def twoargs_test(arg1,arg2):
    return 1,"twoargs(%s,%s)"%(arg1,arg2)

#pyrapi:infargs_test:
def infargs_test(*args):
    return 1,"infargs(%d args)"%(len(args))

#pyrapi:getvar_test:name
def getvar_test(name):
    retcode,res=submod_execcmd("getvar@varmod","id","default",name)
    if retcode==0:
        return 0,"cant getvar: %s"%(res)
    return 1,res

#pyrapi:varmod_test:
def varmod_test():
    retcode,res=submod_execcmd("setvar@varmod","id","default","x","2")
    if retcode==0:
        return 0,"cant setvar: %s"%(res)
    return 1,"ok"

#pyrapi:newns_test:ns
def newns_test(ns):
    return submod_newns(ns)

 #pyrapi:setvar_test:ns,name,value
def setvar_test(ns,name,value):
    return submod_setvar(ns,name,value,"0")
    
#pyrapi:pool_test:
def pool_test():
    global mypool
    mypool.new("testname",{"test1":"1","test2":2})
    t=mypool.get("testname")
    t["test3"]=3.141692
    t["test4"]=4
    if t["test1"]!="1":
        return 0,"bad value of test1 in ns %s"%(str(t["test1"]))
    if t["test2"]!=2:
        return 0,"bad value of test2 in ns %s"%(str(t["test2"]))
    if t["test3"]!=3.141692:
        return 0,"bad value of test3 in ns %s"%(str(t["test3"]))
    t["test1"]=5
    if t["test1"]!=5:
        return 0,"bad value of test1 in ns %s of type %s"%(t["test1"],type(t["test1"]))

    # find_by_field
    id,val=mypool.find_by_field("test1",5)
    if id!="testname":
        return 0,"invalid id through find_by_field (%s)"%(id)
    if val!=5:
        return 0,"invalid value of test1 through find_by_field (%s)"%(val)
    id,val=mypool.find_by_field("test1","234")
    if id!=-1:
        return 0,"invalid id throguh non existant find_by_field (%s)"%(id)
    if val!=None:
        return 0,"invalid value of test1 through find_by_field (%s)"%(val)

    # test operator "in"
    if "test1" not in t:
        return 0,"test1 not found in t"

    # default value on get
    if t.get("test1","undef")=="undef":
        return 0,"invalid default get for existing key"
    if t.get("asdf","undef")!="undef":
        return 0,"invalid default get for non-existing key"

    return 1,"ok"

#pyrapi:apipools_test:
def apipools_test():
    myapipool=apipools.api_pool()
    myapipool.add_api_from_file("cmd_ps","/opt/pyrame/cmd_ps.api")
    api=myapipool.get_api("cmd_ps","get_voltage_ps")
    pattern=['ps_id']
    if api!=pattern:
	return 0,"%s not equal to %s"%(",".join(api),",".join(pattern))
    return 1,"ok"

def asyncwait_t(bg_context,ptime):
    print("waiting for %s seconds"%(ptime))
    time.sleep(float(ptime))
    print("sleep is finished")
    submod_sendres(bg_context,1,"ok")

#pyrapi:asyncwait_test:time
def asyncwait_test(ptime):
    retcode,res=submod_bgcontext()
    t=threading.Thread(target=asyncwait_t,args=(res,ptime))
    t.start()
    return KEEPOPEN,"ok"
