#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2015 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.

init() { 
    echo "init sh test"
    submod_setmyport 9007
    echo "RETCODE=$RETCODE"
    if test $RETCODE -eq 0
    then
        echo "error in setmyport : $RETSTR"
    fi
    echo "the error msg is $RETSTR"
    j="0"
    for i in $@
    do
        echo "arg $j : $i"
        j=`expr $j + 1`
    done
}

#pyrapi:void_test:
void_test() {
    #echo "inside sh void code"
    submod_setvar "system" "x" "2"
    echo "result of setvar $RETCODE,$RES"
    submod_getvar "system" "x"
    echo "result of getvar $RETCODE,$RES"
    submod_delvar "system" "x"
    echo "result of delvar $RETCODE,$RES"
    submod_setres 1 "void()"
}

#pyrapi:fail_test:
fail_test() {
    submod_setres 0 "fail()"
}

#pyrapi:getmyport_test:
getmyport_test() {
    submod_getmyport
    #echo "the port is $RETSTR"
    submod_setres $RETCODE $RETSTR
}

#pyrapi:getmyfile_test:
getmyfile_test() {
    submod_getmyfile
    submod_setres $RETCODE $RETSTR
}

#pyrapi:onearg_test:arg1
onearg_test() {
    if test $# != "1" 
    then
        submod_setres 0 "1 arg needed : $# provided"
    else
        submod_setres 1 "onearg($1)"
    fi
}

#pyrapi:twoargs_test:arg1,arg2
twoargs_test() {
    if test $# != "2" 
    then
        submod_setres 0 "2 arg needed : $# provided"
    else
        submod_setres 1 "twoargs($1,$2)"
    fi
}

#pyrapi:varmod_test:
varmod_test() {
    submod_execcmd "setvar@varmod" "id" "default" "x" "2"
    echo "varmod_test retcode : $RETCODE"
    echo "varmod_test retstr : $RETSTR"
    if test $RETCODE != "1"
    then
        submod_setres 0 "cant exec setvar : $RETSTR"
    else
        submod_setres 1 "ok"
    fi
}
