#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2015 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.
. /usr/local/bin/unit_test_lib.sh
. /opt/pyrame/ports.sh

clean_all
echo
echo
echo "TEST $1 TESTS"
echo
cmdmod /opt/pyrame/$2 -a 1 2 > server.trace 2>&1 &
cmdmod /opt/pyrame/cmd_varmod.xml > varmod.trace 2>&1 &
wait_until_awake localhost $TEST_PORT
wait_until_awake localhost $VARMOD_PORT
exec_n_test ./void.sh
checkretstr 9007 ./getmyport.sh
checkretstr "onearg(test1)" ./onearg.sh test1
checkretstr "onearg(quote\"test)" ./onearg.sh "quote\"test"
checkretstr "onearg(percent%dtest)" ./onearg.sh "percent%dtest"
checkretstr "onearg()"      ./onearg.sh ""
exec_n_test_fail ./onearg.sh
checkretstr "twoargs(test1,test2)" ./twoargs.sh test1 test2
exec_n_test_fail ./fail.sh
exec_n_test ./varmod.sh
exec_n_test ./onearg.sh `cat logo.b64`
checkretstr /opt/pyrame/$3 ./getmyfile.sh
exec_n_test ./exit.sh
clean_all


