/*
Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
This file is part of Pyrame.

Pyrame is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Pyrame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
*/

#include "cmd_cons.h"

void newevt(void *workspace,struct event *e) {
  //printf("new event\n");
}

void newblock(void *workspace,struct block *b) {
  struct cons_ws *ws=(struct cons_ws *)workspace;
  //struct timeval now;
  //gettimeofday(&now,NULL);
  //printf("got block at %ld.%06ld\n",now.tv_sec,now.tv_usec);
  //printf("got block %s\n",get_block_field(b,"a"));
  ws->received_blocks++;
  if (ws->received_blocks==1) {
    gettimeofday(&(ws->t1),NULL);
//    printf("got block at %d at %ld.%06ld\n",ws->received_blocks,ws->t1.tv_sec,ws->t1.tv_usec);
  }
  if (ws->received_blocks==ws->total_blocks) {
    gettimeofday(&(ws->t2),NULL);
//    printf("got block at %d at %ld.%06ld\n",ws->received_blocks,ws->t2.tv_sec,ws->t2.tv_usec);
  }
}

void endblock(void *workspace,struct block *b) {
  //printf("end of block\n");
}

void reinit(void *workspace) {
  //printf("reinit\n");
}

//pyrapi:get_rblocks_cons:
struct cmd_result * get_rblocks_cons(struct cmd *command,void *workspace) {
  struct cons_ws *ws=(struct cons_ws *)workspace;
  char res[48];
  sprintf(res,"%d",ws->received_blocks);
  return raw_build_result(1,res);
}

//pyrapi:start_cons:total_blocks
struct cmd_result * start_cons(struct cmd *command,void *workspace) {
  struct cons_ws *ws=(struct cons_ws *)workspace;
  if (command->nb_params<1) {
    return build_result(0,"cons: 1 arg needeed: %d provided",command->nb_params);
  }
  ws->total_blocks=atoi(command->params[0]);
  stop_loop(ws->loop);
  ws->received_blocks=0;
  rewind_loop(ws->loop);
  run_loop(ws->loop);
  return raw_build_result(1,"ok");
}

//pyrapi:start_sync_cons:total_blocks
struct cmd_result * start_sync_cons(struct cmd *command,void *workspace) {
  struct cons_ws *ws=(struct cons_ws *)workspace;
  struct sched_param schedp;
  memset(&schedp,0,sizeof(schedp));
  schedp.sched_priority=80;
  double etime;
  if (command->nb_params<1) {
    return build_result(0,"cons: 1 arg needeed: %d provided",command->nb_params);
  }
  ws->total_blocks=atoi(command->params[0]);
  stop_loop(ws->loop);
  ws->received_blocks=0;
  rewind_loop(ws->loop);
  run_loop(ws->loop);
  sched_setscheduler(0,SCHED_RR,&schedp);
  while (ws->received_blocks<ws->total_blocks) {
    usleep(10);
  }
  sched_setscheduler(0,SCHED_OTHER,&schedp);
  etime=ws->t2.tv_sec-ws->t1.tv_sec+(ws->t2.tv_usec-ws->t1.tv_usec)/(double)1e6;
  return build_result(1,"%f",etime);
}

void *init(int argc,char **argv) {
  struct cons_ws *ws;
  ws=(struct cons_ws*)malloc(sizeof(struct cons_ws));
  ws->loop=new_event_loop("gen",ws,newevt,newblock,endblock,reinit,'f');
  return ws;
}
