/*
 * Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
 * This file is part of Pyrame.
 *
 * Pyrame is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pyrame is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Pyrame.  If not, see <http://www.gnu.org/licenses/>
 * */

#include "../bindings/bindpyrame.h"


int main() {
  struct timeval t1;
  struct timeval t2;
  int nb=100000;
  int i;
  int s;
  int etime;


  printf("with single socket open\n");
  s=open_socket("10.220.0.97",9404);
  gettimeofday(&t1,NULL);
  for (i=0;i<nb;i++) {
    execcmd(s,"basic_test","end");
  }
  gettimeofday(&t2,NULL);
  etime=(t2.tv_sec-t1.tv_sec)*1000000+(t2.tv_usec-t1.tv_usec);
  printf("elapsed time : %f us/op\n",((float)etime)/nb);
  close(s);

  printf("with one socket open per operation\n");
  gettimeofday(&t1,NULL);
  for (i=0;i<nb;i++) {
    s=open_socket("10.220.0.97",9404);
    execcmd(s,"basic_test","end");
    close(s);
  }
  gettimeofday(&t2,NULL);
  etime=(t2.tv_sec-t1.tv_sec)*1000000+(t2.tv_usec-t1.tv_usec);
  printf("elapsed time : %f us/op\n",((float)etime)/nb);
}
