#!/bin/sh
# -*- coding: utf-8 -*-
# 
# Copyright 2012-2017 Frédéric Magniette, Miguel Rubio-Roy
# This file is part of Pyrame.

init() {
    if test -f /usr/bin/elog
    then
        echo "elog found"
    else
        echo "elog not found...exiting"
        submod_exit 1
    fi
}

init_elog() {
    #$1 elog_id
    #$2 server
    #$3 port
    #$4 elog_name
    HOSTS[$1]=$2
    PORTS[$1]=$3
    NAMES[$1]=$4
    submod_setres 1 "ok"
}

deinit_elog() {
    #$1 elog_id

    if test a${HOSTS[$1]} = a
    then
        submod_setres 0 "unknown elog_id"
        return
    fi
    
    HOSTS[$1]=""
    PORTS[$1]=""
    NAMES[$1]=""
    submod_setres 1 "ok"
}

add_msg_elog() {
    #$1 elog_id
    #$2 type
    #$3 title
    #$4 msg

    if test a${HOSTS[$1]} = a
    then
        submod_setres 0 "unknown elog_id"
        return
    fi
    
    echo $4 | iconv -f 'UTF-8' -t 'ISO-8859-1' | elog -h ${HOSTS[$1]} -p ${PORTS[$1]} -l ${NAMES[$1]} -u ecal calice -a Type="$2" -a Subject="$3"
    submod_setres 1 "ok"
}

add_msgb64_elog() {
    #$1 elog_id
    #$2 type
    #$3 title
    #$4 msg

    if test a${HOSTS[$1]} = a
    then
        submod_setres 0 "unknown elog_id"
        return
    fi
    
    TITLE=`echo $3 | base64 -d | iconv -f 'UTF-8' -t 'ISO-8859-1'`
    echo $4 | base64 -d | iconv -f 'UTF-8' -t 'ISO-8859-1' | elog -h ${HOSTS[$1]} -p ${PORTS[$1]} -l ${NAMES[$1]} -u ecal calice -a Type="$2" -a Subject="$TITLE"
    submod_setres 1 "ok"
}

add_msg_file_elog() {
    #$1 elog_id
    #$2 type
    #$3 title
    #$4 msg file

    if test a${HOSTS[$1]} = a
    then
        submod_setres 0 "unknown elog_id"
        return
    fi
    
    cat $4 | elog -h ${HOSTS[$1]} -p ${PORTS[$1]} -l ${NAMES[$1]} -u ecal calice -a Type="$2" -a Subject="$3"
    submod_setres 1 "ok"
}
